'use strict';const App=require("electron").app;const Url=require("url");const FS=require("fs");const Common=require("../common");const HttpsCom=require("../service/lib/https_com");const ECEvent=require("../service/lib/ec_event");const Log=require("../service/lib/ec_log");const ECUtil=require("../service/lib/ec_util");const ECMenu=require("../service/lib/ec_menu");const Logout=require("../service/auth/logout");const AuthController=require("./auth_controller");const ECWindow=require("../windows/js/ec_window");
const ECTray=require("../windows/js/ec_tray");const SessionQuerryTimer=require("../service/lib/session_querry_timer");const ECI18n=require("../service/lib/ec_i18n");function HttpsComController(){this.mIsInited=false}HttpsComController.prototype.init=function(){if(this.mIsInited)return;Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Starting initializing HttpsComController...");this.mIsInited=true;this.initEvent();this.initHttpsCom();this.mLoggedOut=false};
HttpsComController.prototype.requestECAgent=function(op,args,callback){var logStr="Comm with ECAgent and the op is "+op;if(op!=="ImportCert")logStr+=" args are "+JSON.stringify(args);this.mHttpsCom.ECAgent(op,args,callback)};
HttpsComController.prototype.initEvent=function(){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Starting initializing event...");ECEvent.on(Common.EVENT_HTTPS_INIT_OK,()=>{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Received ec_event: "+Common.EVENT_HTTPS_INIT_OK);Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Initialize HttpsComController successfully!");this.mInitializing=false;if(!gStartFromECAgent)this.requestECAgent(Common.HTTPS_DO_CONFIGURE,{arg1:"SET LANG "+gLanguage,callback:Common.CONFIGURE_LANG_CALLBACK});
this.requestECAgent(Common.HTTPS_GET_ENCRYPT_KEY,{callback:Common.GET_ENCRYPT_KEY_CALLBACK})});ECEvent.on(Common.EVENT_HTTPS_INIT_ERROR,()=>{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Received ec_event: "+Common.EVENT_HTTPS_INIT_ERROR);this.mIsInited=false;ECUtil.showMessageBox(null,{type:"warning",title:ECI18n("Alert"),message:ECI18n("Initialization failed. Please try reinstalling!")});ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+Common.INSTALL_URL+"?language\x3d"+gLanguage);ECUtil.exit(0)});
ECEvent.on(Common.EVENT_HTTPS_DATA,(resStr)=>{try{eval(resStr)}catch(exception){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Can not eval("+resStr+")"+exception.stack)}});ECEvent.on(Common.EVENT_HTTPS_GET_REQUEST_ERROR,(error)=>{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Received ec_event:"+Common.EVENT_HTTPS_GET_REQUEST_ERROR);Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Request ECAgent error: "+error);switch(gCurrState){case Common.STATE_UNINITIALIAZED:case Common.STATE_INITIALIZING:case Common.STATE_LINE:case Common.STATE_AUTH:case Common.STATE_SET_TWFID:break;
case Common.STATE_START_SERVICE:if(typeof global.gQuerryStateTimer!=="undefined"&&global.gQuerryStateTimer!=null){clearInterval(global.gQuerryStateTimer);global.gQuerryStateTimer=null}break;case Common.STATE_TRAY:if(gECTray!=null)gECTray.clearTimer();if(gControllers.sessionQuerryTimer!=null)clearInterval(gControllers.sessionQuerryTimer);gControllers.sessionQuerryTimer=null;break}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"Start timeout to init httpsCom...");if(!this.mInitializing){this.mInitializing=
true;setTimeout(()=>{if(gControllers.httpsCom!=null)gControllers.httpsCom.initHttpsCom()},1E4)}});Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Initialize event successfully!")};HttpsComController.prototype.initHttpsCom=function(){if(!this.mHttpsCom)this.mHttpsCom=new HttpsCom;this.mHttpsCom.init()};
HttpsComController.prototype.checkForceUpdate=function(doNotUpdate,update){if(!FS.existsSync(Common.LE_VERSION_CONF_PATH)){doNotUpdate();return}try{var leVerXml=FS.readFileSync(Common.LE_VERSION_CONF_PATH,{encode:"UTF-8"});const xml2js=require("../node_modules/xml2js");var parser=new xml2js.Parser;parser.parseString(leVerXml,(err,leVerObj)=>{if(err){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"parseString error: "+err);doNotUpdate();return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"leVerJSON: "+JSON.stringify(leVerObj));
var leVer=null;var verXml=FS.readFileSync(Common.VERSION_CONF_PATH,{encode:"UTF-8"});var parserVer=new xml2js.Parser;parserVer.parseString(verXml,(err,verObj)=>{if(err){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"parseString error: "+err);doNotUpdate();return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,JSON.stringify(verObj));var alias=null,version=null,pkg=null,arch=null;alias=verObj["root"]["alias"][0];version=verObj["root"]["version"][0];if(gOS===Common.SYS_LINUX){pkg=verObj["root"]["pkg"][0];arch=
verObj["root"]["arch"][0]}var leVer=null;var os="mac";if(gOS===Common.SYS_MAC){os="mac";leVer=leVerObj["root"][os][0][alias][0]["force_update_le"][0]}else if(gOS===Common.SYS_LINUX){os="linux";leVer=leVerObj["root"][os][0][alias][0][pkg][0][arch][0]["force_update_le"][0]}if(this.cmpVer(leVer,version)){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Need update next time!");update();return}else{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Do not need update next time!");doNotUpdate();return}})})}catch(error){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"Read "+Common.LE_VERSION_CONF_PATH+" error: "+error);doNotUpdate();return}};
HttpsComController.prototype.cmpVer=function(leVer,currVer){if(leVer==null)return false;if(currVer==null)return true;Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Compare(leVer: "+leVer+" currVer: "+currVer+")");var leVerArray=leVer.split(".");var currVerArray=currVer.split(".");var maxLen=leVerArray.length>currVerArray.length?leVerArray.length:currVerArray.length;for(var i=0;i<maxLen;++i){var leInt=0,currInt=0;if(leVerArray[i]!=null)try{leInt=parseInt(leVerArray[i]);if(isNaN(leInt))leInt=0}catch(e){leInt=
0}if(currVerArray[i]!=null)try{currInt=parseInt(currVerArray[i]);if(isNaN(currInt))currInt=0}catch(e){currInt=0}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"leInt: "+leInt+" currInt: "+currInt);if(leInt>currInt)return true;else if(leInt<currInt)return false}return true};
HttpsComController.prototype.doStartFromECAgent=function(){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Do Start from ECAgent!");this.checkForceUpdate(()=>{this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY LANG",callback:Common.QUERY_LANG_CALLBACK});this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY BROWSER",callback:Common.QUERY_BROWSER_CALLBACK})},()=>{gControllers.httpsCom.requestECAgent("Logout",{callback:"this.logoutCallback"});ECEvent.once(Common.EVENT_FORCE_UPDATE_LOGOUT_OK,function(){ECUtil.showMessageBox(null,
{type:"warning",title:ECI18n("Alert"),message:ECI18n("The EasyConnect version is too low. Please update the client to the latest version.")});ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+Common.INSTALL_URL+"?language\x3d"+gLanguage);ECUtil.exit(0)});(new Logout(Common.LOGOUT_FORCE_UPDATE)).doRequestAuth(gAuthInfo["authUrl"],null)})};
HttpsComController.prototype.checkUpdateEC=function(){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"Start Update ");this.requestECAgent(Common.HTTPS_UPDATE_CONTROLS,{arg1:"BEFORELOGIN",callback:Common.UPDATE_CONTROLS_CALLBACK})};HttpsComController.prototype.updateProcess=function(){this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY CONTROLS UPDATEPROCESS",callback:Common.UPDATE_PROCESS_CALLBACK})};
HttpsComController.prototype.initECAgentCallback=function(resStr){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"initECAgentCallback");if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"initECAgentCallback resStr is null");return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"initECAgentCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==="")Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"initECAgent: "+(resObj["message"]?resObj["message"]:"Request result is null!"));if(resObj["result"]===Common.INIT_ECAGENT_OK)this.checkUpdateEC();else{Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Init ECAgent fialed!");setTimeout(()=>{var urlObj=Url.parse(gAuthInfo["authUrl"]);gControllers["httpsCom"].requestECAgent("InitECAgent",{arg1:urlObj.hostname+" "+(urlObj.port?urlObj.port:"443"),token:gAuthInfo["currToken"],callback:Common.INIT_ECAGENT_CALLBACK})},Common.HTTPS_RETRANSMISSION_TIMEOUT)}};
HttpsComController.prototype.updateControlsCallback=function(resStr){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"updateControlsCallback");if(resStr==null||resStr==="")Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"updateControlsCallback resStr is null");var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"updateControlsCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]=="")Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"updateControls: "+(resObj["message"]?resObj["message"]:"Request result is null!"));this.updateProcess()};
HttpsComController.prototype.updateProcessCallback=function(resStr){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"updateProcessCallback");var updateProcessOk=true;if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"updateProcessCallback resStr is null");updateProcessOk=false}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"updateProcessCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==
""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"updateProcess: "+(resObj["message"]?resObj["message"]:"Request result is null!"));updateProcessOk=false}if(!updateProcessOk){setTimeout(()=>{this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY CONTROLS UPDATEPROCESS",callback:Common.UPDATE_PROCESS_CALLBACK})},Common.UPDATE_PROCESS_TIMEOUT);return}switch(resObj["result"]){case Common.UPDATE_INPROCESS:setTimeout(()=>{this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY CONTROLS UPDATEPROCESS",callback:Common.UPDATE_PROCESS_CALLBACK})},
Common.UPDATE_PROCESS_TIMEOUT);break;case Common.UPDATE_ISUPTODATE:this.checkForceUpdate(()=>{if(gOS===Common.SYS_MAC||gOS===Common.SYS_LINUX)gControllers["httpsCom"].requestECAgent(Common.HTTPS_INIT_SERVER_CERT,{callback:Common.INIT_SERVER_CERT_CALLBACK});else{gControllers["httpsCom"].requestECAgent("GetCertificates",{callback:Common.GET_CERTIFICATES_CALLBACK});if(gControllers.auth==null){gControllers.auth=new AuthController;gControllers.auth.init()}gControllers["auth"].startAuth()}},()=>{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,
"Force to update!");var ret=ECUtil.showMessageBox(null,{type:"info",title:ECI18n("Prompt"),buttons:[ECI18n(" Cancel "),ECI18n(" OK ")],message:ECI18n("The EasyConnect version is too low. Please update the client to the latest version.")});if(ret===Common.TWO_BUTTONS_OK){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+Common.INSTALL_URL+"?language\x3d"+gLanguage);ECUtil.exit(0)}else if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW)});
break;case Common.UPDATE_NEEDREINSTALL:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"The alias dismatched, need to update.");var ret=ECUtil.showMessageBox(null,{type:"info",title:ECI18n("Prompt"),buttons:[ECI18n(" Cancel "),ECI18n(" OK ")],message:ECI18n("The EasyConnect version is not consistent with server version. Please update the client.")});if(ret===Common.TWO_BUTTONS_OK){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+Common.INSTALL_URL+"?language\x3d"+gLanguage);ECUtil.exit(0)}else if(gECWindow!=
null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW);break;case Common.UPDATE_OLD_VERSION:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Old device using plugin!");var ret=ECUtil.showMessageBox(null,{type:"info",title:ECI18n("Prompt"),buttons:[ECI18n(" Cancel "),ECI18n(" OK ")],message:ECI18n("The EasyConnect version is not consistent with server version. Please update the client.")});if(ret===Common.TWO_BUTTONS_OK){ECUtil.openExternalUrl(Common.BROWSER_TYPE_SAFARI,
gAuthInfo["authUrl"]+Common.OLD_VERSION_INSTALL_URL);ECUtil.exit(0)}else if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW);break;case Common.UPDATE_REQ_TIMEOUT:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_SELECT_LINE_ERROR);ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN);break;default:setTimeout(()=>{this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY CONTROLS UPDATEPROCESS",
callback:Common.UPDATE_PROCESS_CALLBACK})},Common.UPDATE_PROCESS_TIMEOUT);break}};
HttpsComController.prototype.initServerCertCallback=function(resStr){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"initServerCertCallback");var initOk=true;if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"initServerCertCallback resStr is null");initOk=false}else{var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"initServerCertCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]===
""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"initServerCertCallback: "+(resObj["message"]?resObj["message"]:"Request result is null!"));initOk=false}else if(resObj["result"]===Common.INIT_SERVER_CERT_OK)initOk=true;else{Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Init Server cert error, error code: "+resObj["result"]);initOk=false}}if(!initOk){ECUtil.showMessageBox(null,{type:"warning",title:ECI18n("Alert"),message:ECI18n("Failed to connect to server. Please check whether the network works well.")});
if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW)}else{gControllers["httpsCom"].requestECAgent(Common.HTTPS_GET_CERTIFICATES,{callback:Common.GET_CERTIFICATES_CALLBACK});if(gControllers.conf!=null){gControllers["conf"].addUrl(gAuthInfo["selectLineUrl"]);gControllers.conf.save()}if(gControllers.auth==null){gControllers.auth=new AuthController;gControllers.auth.init()}gControllers["auth"].startAuth()}};
HttpsComController.prototype.checkReloginCallback=function(resStr){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"checkReloginCallback");if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"checkReloginCallback resStr is null");return}var hasUserLogin=true;var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"checkReloginCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"checkRelogin: "+(resObj["message"]?resObj["message"]:"Request result is null!"));hasUserLogin=true}if(resObj["result"]==Common.RELOGIN){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"checkRelogin: Relogin!");hasUserLogin=true}else if(resObj["result"]==Common.UNLOGIN){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"checkRelogin: Unlogin");hasUserLogin=false}else if(resObj["result"]==Common.OTHER_USER_LOGIN){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"checkRelogin: Other User Login");hasUserLogin=true}else{Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"Cannot understand the checkRelogin Result: "+resObj["result"]);hasUserLogin=true}if(hasUserLogin){ECUtil.showMessageBox(null,{type:"warning",title:ECI18n("Alert"),message:ECI18n("Failed to login in with this user account, for a user is online!")});if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW)}else{var urlObj=Url.parse(gAuthInfo["authUrl"]);gControllers["httpsCom"].requestECAgent(Common.HTTPS_INIT_ECAGENT,{arg1:urlObj["hostname"]+
" "+(urlObj["port"]!=null?urlObj.port:"443"),token:gAuthInfo["currToken"],callback:Common.INIT_ECAGENT_CALLBACK})}};
HttpsComController.prototype.getEncryptKeyCallback=function(resStr){var getEncOk=true;if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryEncryptKeyCallback resStr is null");getEncOk=false}var resObj=null;if(getEncOk){try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getEncryptKeyCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""||resObj["result"]==Common.HTTPS_TOKEN_DENIED){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"querryEncryptKeyCallback: "+(resObj["message"]?resObj["message"]:"Request result is null!"));getEncOk=false}}if(!getEncOk){if(gStartFromECAgent){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Failed to get encrypt key.");ECUtil.doLogout()}else setTimeout(()=>{gControllers.httpsCom.requestECAgent("GetEncryptKey",{callback:Common.GET_ENCRYPT_KEY_CALLBACK})},2E3);return}gECAgent["encryptKey"]=resObj["result"];if(gCurrState===Common.STATE_LINE||gCurrState==Common.STATE_INITIALIZING)Log.info(Common.LOG_HTTPS_COM_CONTROLLER,
"gCurrState: "+gCurrState);else Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Start to recover according to gCurrState: "+gCurrState);switch(gCurrState){case Common.STATE_UNINITIALIAZED:break;case Common.STATE_INITIALIZING:if(gStartFromECAgent)this.doStartFromECAgent();else gControllers.httpsCom.requestECAgent(Common.HTTPS_CHECK_LOGIN,{arg1:null,callback:Common.CHECK_RELOGIN_CALLBACK});break;case Common.STATE_LINE:if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,
null,Common.LINE_WINDOW);break;case Common.STATE_AUTH:if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.AUTH_WINDOW);break;case Common.STATE_SET_TWFID:if(gControllers.auth==null){gControllers.auth=new AuthController;gControllers.auth.init()}var urlObj=Url.parse(gAuthInfo["authUrl"]);gControllers["httpsCom"].requestECAgent("DoConfigure",{arg1:"SET SERVADDR "+urlObj.hostname+" "+(urlObj.port?urlObj.port:"443"),token:gAuthInfo["currToken"],callback:Common.CONFIGURE_SERV_ADDR_CALLBACK});
break;case Common.STATE_START_SERVICE:if(gControllers.auth==null){gControllers.auth=new AuthController;gControllers.auth.init()}gControllers["auth"].startService();break;case Common.STATE_TRAY:if(gStartTray||!gStartFromECAgent)if(gECTray==null)gECTray=new ECTray(Common.TRAY_HAVE_ICO);else gECTray.initTimer();else ECUtil.exit(0);if(gECWindow!=null){gECWindow.close();gECWindow=null}if(gControllers.sessionQuerryTimer==null)gControllers["sessionQuerryTimer"]=new SessionQuerryTimer;gControllers["sessionQuerryTimer"].init();
break}};
HttpsComController.prototype.getEncryptKeyForCertAndTwfid=function(resStr){var getEncOk=true;if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getEncryptKeyForCertAndTwfid resStr is null");getEncOk=false}var resObj=null;if(getEncOk){try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getEncryptKeyForCertAndTwfid (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""||resObj["result"]==Common.HTTPS_TOKEN_DENIED){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getEncryptKeyForCertAndTwfid: "+
(resObj["message"]?resObj["message"]:"Request result is null!"));getEncOk=false}}if(!getEncOk){ECEvent.emit(Common.EVENT_GET_ENCRYPT_KEY_FOR_CERT_AND_TWFID_RES,Common.GET_ENCRYPT_KEY_ERROR);return}gECAgent["encryptKey"]=resObj["result"];ECEvent.emit(Common.EVENT_GET_ENCRYPT_KEY_FOR_CERT_AND_TWFID_RES,Common.GET_ENCRYPT_KEY_OK)};
HttpsComController.prototype.importCertCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"importCertCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"importCertCallback: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"importCertCallback result: "+resStr);this.requestECAgent("GetCertificates",
{callback:Common.GET_CERTIFICATES_CALLBACK});ECEvent.emit(Common.EVENT_IMPORT_CERT_RES,resObj)};
HttpsComController.prototype.getCertificatesCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getCertificatesCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getCertificatesCallback: Request result is null!");return}var certsArray=resObj["result"];var certsNum=certsArray.length;Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,certsNum+" certs: "+certsArray);
gAuthInfo["oldCerts"]=JSON.parse(JSON.stringify(gAuthInfo["certs"]));gAuthInfo["certs"]={};for(var i=0;i<certsArray.length;++i)if("certLabel"in certsArray[i]&&"serialNum"in certsArray[i]){var tmp=certsArray[i]["certLabel"]+certsArray[i]["serialNum"];gAuthInfo["certs"][tmp]={certLabel:certsArray[i]["certLabel"],serialNum:certsArray[i]["serialNum"]}}ECEvent.emit(Common.EVENT_GET_CERTIFICATES_OK)};
HttpsComController.prototype.certAuthCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"certAuthCallback resStr is null");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"certAuthCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""||!("message"in resObj)){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"certAuthCallback: Request result or message is null!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}if(typeof resObj["result"]!=="string"||typeof resObj["message"]!=="string"){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"certAuthCallback: Request result or message is not string!");return}const Base64=require("../service/lib/base64");var authResObj={};authResObj["result"]=Base64.decode(resObj["result"]);authResObj["message"]=Base64.decode(resObj["message"]);var authResStr=
JSON.stringify(authResObj);Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"certAuthCallback: "+authResStr);ECEvent.emit(Common.EVENT_CERT_AUTH_RESULT,authResStr)};
HttpsComController.prototype.queryLangCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"queryBrowserCallback resStr is null");return}var resObj=JSON.parse(resStr);if(resObj["result"]==="zh_CN"||resObj["result"]==="en_US"){gLanguage=resObj["result"];gControllers.conf.setUrl(null,"language",gLanguage);gControllers.conf.save()}};
HttpsComController.prototype.queryBrowserCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"queryBrowserCallback resStr is null");gBrowser=Common.BROWSER_TYPE_UNKOWN}else{var resObj=null;try{resObj=JSON.parse(resStr);gBrowser=resObj["result"]}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"queryBrowserCallback (Fail to parse the resStr: "+resStr+")");gBrowser=Common.BROWSER_TYPE_UNKOWN}}if(gStartFromECAgent){if(!gControllers.auth)gControllers.auth=
new AuthController;gControllers.auth.init();gCurrState=Common.STATE_SET_TWFID;ECEvent.emit(Common.EVENT_CONFIGURE_TWFID_OK)}};
HttpsComController.prototype.querryHardIDCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryHardIDCallback resStr is null");Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_HARD_ID_ERROR);return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"get_hard_id: "+(resObj["message"]?resObj["message"]:
"Request result is null!"));Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_HARD_ID_ERROR);return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"start querryHardIDCallback");var strs=resObj["result"].split("|");gAuthInfo["hardID"]["hid"]=strs[0];gAuthInfo["hardID"]["macaddress"]=strs[1];gAuthInfo["hardID"]["hostname"]=strs[2];Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"hardID: "+JSON.stringify(gAuthInfo["hardID"]));
ECEvent.emit(Common.EVENT_GET_HARDID_OK)};
HttpsComController.prototype.querryLoginAddrCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryLoginAddrCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryLoginAddr: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}if(resObj["result"]!==Common.TOKEN_CHECK_ERROR){gAuthInfo[Common.AUTHINFO_SELECT_LINE_URL]=resObj["result"];
gControllers.conf.addUrl(gAuthInfo[Common.AUTHINFO_SELECT_LINE_URL]);gControllers.conf.save()}};
HttpsComController.prototype.querrySessionIDCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querrySessionIDCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querrySessionID: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}if(resObj["result"]!==Common.TOKEN_CHECK_ERROR){gAuthInfo.preToken=gAuthInfo.currToken;gAuthInfo.currToken=
resObj["result"];ECUtil.parseSetCookies(["TWFID\x3ddeleted","TWFID\x3d"+resObj["result"]+";path\x3d/;secure"])}else Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querrySessionID: "+(resObj["message"]?resObj["message"]:"Token check error!"))};
HttpsComController.prototype.startServiceCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"startServiceCallback resStr is null");ECEvent.emit(Common.EVENT_START_SERVICE_ERROR);return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"startServiceCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"startServiceCallback: "+
(resObj["message"]?resObj["message"]:"Request result is null!"));ECEvent.emit(Common.EVENT_START_SERVICE_ERROR);return}if(resObj["result"]===Common.START_SERVICE_OK){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_START_SERVICE_OK);ECEvent.emit(Common.EVENT_START_SERVICE_OK)}else{Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"StartServices result: "+resObj["result"]);Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_START_SERVICE_ERROR);ECEvent.emit(Common.EVENT_START_SERVICE_ERROR)}};
HttpsComController.prototype.querryQstateAllServicesCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryQstateAllServicesCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryQstateAllServices: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}ECEvent.emit(Common.EVENT_QSTATE_RESULT,Common.QSTATE_ALLSERVICES,resObj["result"])};
HttpsComController.prototype.querryQstateL3VPNCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryQstateL3VPNCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryQstateAllServices: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}ECEvent.emit(Common.EVENT_QSTATE_RESULT,Common.QSTATE_L3VPN,resObj["result"])};
HttpsComController.prototype.querryLogoutCallback=function(resStr){if(this.mLoggedOut)return;if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryLogoutCallback resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"querryLogout: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}if(resObj["result"]==Common.USER_ALIVE);else if(resObj["result"]==Common.USER_LOGOUT){this.mLoggedOut=
true;Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"querryLogout: The user logged out!");if(gControllers["sessionQuerryTimer"]!=null)gControllers["sessionQuerryTimer"].clear();gControllers.sessionQuerryTimer=null;if(resObj["message"]===Common.LOGOUT_TYPE_LOGOUT)ECUtil.exit(0);else{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"The user logged out, logged-out code: "+resObj["message"]);gCurrState=Common.STATE_LOGOUT;if(gECTray!=null){gECTray.destroy();gECTray=null}App.releaseSingleInstance();ECEvent.once(Common.EVENT_LOGOUT_BE_LOGGEDOUT_OK,
function(){ECUtil.showMessageBox(null,{type:"warning",title:ECI18n("Prompt"),message:ECI18n("Time out or you are kicked offline.")});ECUtil.exit(0)});(new Logout(Common.LOGOUT_BE_LOGGEDOUT)).doRequestAuth(gAuthInfo["authUrl"],null)}}else if(resObj["result"]==Common.USER_SESSION_CHANGE){Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"querryLogout: Session change!");this.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY QSESSIONID",callback:Common.QUERRY_SESSIONID_CALLBACK})}else Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"Cannot understand the querryLogout Result: "+resObj["result"])};
HttpsComController.prototype.querryTrayStatCallback=function(resStr){if(resStr==null||resStr==="")return;var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]=="")return;var stateInfo=resObj["result"];if(typeof stateInfo!=="object")return;gECTrayInfo["vpnState"]=decodeURIComponent(stateInfo["vpnState"]);gECTrayInfo["userName"]=decodeURIComponent(stateInfo["userName"]);gECTrayInfo["ip"]=decodeURIComponent(stateInfo["ip"]);gECTrayInfo["onlineTime"]=decodeURIComponent(stateInfo["onlineTime"]);
gECTrayInfo["virtualIP"]=decodeURIComponent(stateInfo["virtualIp"]);gECTrayInfo["vIPConfilict"]=decodeURIComponent(stateInfo["vIpConfilict"]);gECTrayInfo["speedIn"]=decodeURIComponent(stateInfo["speedIn"]);gECTrayInfo["speedOut"]=decodeURIComponent(stateInfo["speedOut"]);gECTrayInfo["fluxIn"]=decodeURIComponent(stateInfo["fluxIn"]);gECTrayInfo["fluxOut"]=decodeURIComponent(stateInfo["fluxOut"]);if(!gVirtualIpConflictShown&&gECTrayInfo["vIPConfilict"]===Common.STATE_YES){ECUtil.showMessageBox(Common.DIALOG_SHOW_AS_INDIVIDUAL_WINDOW,
{type:"warning",title:ECI18n("Prompt"),message:ECI18n("IP of virtual and local network adapters are conflicting. Please contact the network administrator.")});gVirtualIpConflictShown=true}if(gECTrayInfo["vpnState"]===Common.TRAY_STATE_ONLINE){if(gIsChangingVPNLine)if(gECTray!=null)gECTray.setTrayOnline();gIsChangingVPNLine=false}else if(gECTrayInfo["vpnState"]===Common.TRAY_STATE_OFFLINE)if(!gIsChangingVPNLine){if(gECTray!=null)gECTray.setTrayOffline();gIsChangingVPNLine=true;if(gControllers.line==
null){const LineHandlerController=require("./line_handler_controller");gControllers.line=new LineHandlerController;gControllers.line.init()}gControllers.line.startSelectLine(gAuthInfo["selectLineUrl"],Common.LINE_CHANGE_LINE)}ECEvent.emit(Common.EVENT_CONNECT_STATE_UPDATE,JSON.stringify(gECTrayInfo))};
HttpsComController.prototype.querryMessagesCallback=function(resStr){if(resStr==null||resStr==="")return;var resObj=JSON.parse(resStr);if(!("result"in resObj))return;if(resObj["result"]===Common.TOKEN_CHECK_ERROR){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Token Check Error!");return}var msgs=resObj["result"];if(msgs.length<=0)return;else{Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Received new message!");for(var i=0;i<msgs.length;++i)msgs[i]=decodeURIComponent(msgs[i])}var oldLen=gECTrayInfo.messages.length;
var newLen=msgs.length;var newMsgs=null;if(oldLen<newLen){newMsgs=msgs.slice(oldLen);gECTrayInfo.messages=msgs}if(newMsgs!=null)ECEvent.emit(Common.EVENT_NEW_MESSAGE,newMsgs)};
HttpsComController.prototype.configureServAddrCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureServAddr resStr is null");return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureServAddrCallback (Fail to parse the resStr: "+resStr+")");resObj={}}if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureServAddr: "+(resObj["message"]?resObj["message"]:
"Request result is null!"));ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_SERRADDR_ERROR);return}switch(resObj["result"]){case Common.CONFIGURE_SERV_ADDR_OK:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Configure serv_addr ok!");ECEvent.emit(Common.EVENT_SET_SERVADDR_OK);return;case Common.CONFIGURE_SERV_ADDR_ERROR:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Configure serv_addr error!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_SERRADDR_ERROR);return;default:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,
"Cannot understand the configureServAddr Result: "+resObj["result"]);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_SERRADDR_ERROR)}};
HttpsComController.prototype.configureLangCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureLang resStr is null");return}var resObj=JSON.parse(resStr);if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureLang: "+(resObj["message"]?resObj["message"]:"Request result is null!"));return}switch(resObj["result"]){case Common.CONFIGURE_LANG_OK:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Configure Lang ok!");
return;case Common.CONFIGURE_LANG_ERROR:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Configure Lang error!");return;default:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Cannot understand the configureLang Result: "+resObj["result"])}};
HttpsComController.prototype.configureTWFIDCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureTWFID resStr is null");Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_TWFID_EMPTY);return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureTWFIDCallback (Fail to parse the resStr: "+resStr+
")");resObj={}}if(!("result"in resObj)||resObj["result"]==""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"configureTWFID: "+(resObj["message"]?resObj["message"]:"Request result is null!"));Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_TWFID_EMPTY);return}switch(resObj["result"]){case Common.CONFIGURE_TWFID_OK:Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Configure TWFID ok!");ECEvent.emit(Common.EVENT_CONFIGURE_TWFID_OK);
return;case Common.CONFIGURE_TWFID_ERROR:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Configure TWFID error!");Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_CONFIGURE_TWFID_ERROR);return;default:Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Cannot understand the configureTWFIDCallback Result: "+resObj["result"]);Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,
Common.AUTH_CONFIGURE_TWFID_OTHER)}};
HttpsComController.prototype.parseLoginInfo=function(confObj){if(gConf==null){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"parseLoginInfo confObj is null");return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,JSON.stringify(confObj,null,4));try{if("Conf"in confObj&&"WebSecLogin"in confObj.Conf){var webSecLogin=confObj.Conf.WebSecLogin;Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,JSON.stringify(webSecLogin,null,4));if(Common.ECTRAYINFO_LAST_LOGIN_SWITCH in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_SWITCH]!=
null)gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_SWITCH]=webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_SWITCH].trim();if(Common.ECTRAYINFO_LAST_LOGIN_RES in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_RES]!=null)gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_RES]=webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_RES].trim();if(Common.ECTRAYINFO_LAST_LOGIN_TIME in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_TIME]!=null){var time=parseInt(webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_TIME].trim());if(time===
0||isNaN(time)){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"time is 0 or NaN");gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_TIME]=""}else{var dataStr=(new Date(time*1E3)).Format("yyyy-MM-dd hh:mm:ss");gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_TIME]=dataStr}}if(Common.ECTRAYINFO_LAST_LOGIN_TYPE in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_TYPE]!=null)gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_TYPE]=Common.LOGIN_TYPES[webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_TYPE].trim()];if(Common.ECTRAYINFO_LAST_OS_TYPE in
webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_OS_TYPE]!=null)gECTrayInfo[Common.ECTRAYINFO_LAST_OS_TYPE]=Common.LOGIN_OS_TYPES[webSecLogin[Common.ECTRAYINFO_LAST_OS_TYPE].trim()];if(Common.ECTRAYINFO_LAST_LOGIN_IP in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_IP]!=null)gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_IP]=webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_IP.trim()];if(Common.ECTRAYINFO_LAST_LOGIN_SUCC_TIME in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_SUCC_TIME]!=null){var succTime=
parseInt(webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_SUCC_TIME].trim());if(succTime===0||isNaN(succTime)){Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,"succTime is 0 or NaN");gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_SUCC_TIME]=""}else{var succDateStr=(new Date(succTime*1E3)).Format("yyyy-MM-dd hh:mm:ss");gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_SUCC_TIME]=succDateStr}}if(Common.ECTRAYINFO_LAST_LOGIN_FAILS in webSecLogin&&webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_FAILS]!=null)gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_FAILS]=
webSecLogin[Common.ECTRAYINFO_LAST_LOGIN_FAILS].trim()}if("Conf"in confObj&&"Other"in confObj.Conf&&"isPubUser"in confObj.Conf.Other&&confObj.Conf.Other.isPubUser.trim()==="1")gAuthInfo[Common.AUTHINFO_IS_PUB_USER]=true}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Failed to parse Login info, error: "+e)}};
HttpsComController.prototype.getConfCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getConfCallback resStr is null");Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_CONF_EMPTY);return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getConfCallback (Fail to parse the resStr: "+resStr+")");ECEvent.emit(Common.EVENT_AUTH_ERROR,
Common.AUTH_GET_CONF_OR_RCLIST_TOKEN_CHECK_ERROR);return}if(resObj!=null){if(resObj["result"]===Common.TOKEN_CHECK_ERROR){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Get Conf token check error");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_CONF_OR_RCLIST_TOKEN_CHECK_ERROR);return}gConf=resObj;this.parseLoginInfo(gConf)}ECEvent.emit(Common.EVENT_GET_CONF_OK)};
HttpsComController.prototype.getRCListCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getRCListCallback resStr is null");Log.info(Common.LOG_HTTPS_COM_CONTROLLER,"Sending ec_event: "+Common.EVENT_AUTH_ERROR);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_RCLIST_EMPTY);return}var resObj=null;try{resObj=JSON.parse(resStr)}catch(e){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"getRCListCallback (Fail to parse the resStr: "+resStr+")");ECEvent.emit(Common.EVENT_AUTH_ERROR,
Common.AUTH_GET_CONF_OR_RCLIST_TOKEN_CHECK_ERROR);return}if(resObj!=null){if(resObj["result"]===Common.TOKEN_CHECK_ERROR){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"Get rclist token check error");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_GET_CONF_OR_RCLIST_TOKEN_CHECK_ERROR);return}gRCList=resObj}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,JSON.stringify(resObj,null,4));if(gRCList!=null&&"Resource"in gRCList&&"Rcs"in gRCList.Resource&&gRCList.Resource.Rcs!=null&&"Rc"in gRCList.Resource.Rcs){var rcList=
gRCList.Resource.Rcs.Rc;var startTray=false;if(rcList instanceof Array)for(var i=0;i<rcList.length;++i){if(rcList[i]["type"]===Common.RESOURCE_TYPE_L3VPN)gAuthInfo.needStartL3VPN=true;if(rcList[i]["type"]!==Common.RESOURCE_TYPE_WEB)startTray=true}else if(rcList!=null&&"type"in rcList)if(rcList["type"]!==Common.RESOURCE_TYPE_WEB)startTray=true;gStartTray=startTray}ECEvent.emit(Common.EVENT_GET_RCLIST_OK)};
HttpsComController.prototype.logoutCallback=function(resStr){if(resStr==null||resStr===""){Log.warning(Common.LOG_HTTPS_COM_CONTROLLER,"logoutCallback resStr is null");return}Log.debug(Common.LOG_HTTPS_COM_CONTROLLER,resStr)};module.exports=HttpsComController;
