'use strict';const Common=require("../common");const LineHandler=require("../service/line/line_handler");const WebAgentHandler=require("../service/line/web_agent_handler");const MultiLineHandler=require("../service/line/multi_line_handler");const ECEvent=require("../service/lib/ec_event");const Log=require("../service/lib/ec_log");const ECUtil=require("../service/lib/ec_util");const AuthController=require("./auth_controller");const HttpsComController=require("./https_com_controller");
const {app,ipcMain,globalShortcut}=require("electron");const Url=require("url");const ECI18n=require("../service/lib/ec_i18n");function LineHandlerController(){this.mIsInited=false;this.mLineHead=null}LineHandlerController.prototype.init=function(){if(this.mIsInited)return;Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Starting initializing LineHandlerController...");this.initEvent();this.initIPCMain();this.mIsInited=true;Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Initialize LineHandlerController successfully!")};
LineHandlerController.prototype.startSelectLine=function(urlStr,changeLine){this.initLineHandler();this.mIsCancel=false;globalShortcut.register("Escape",()=>{this.mIsCancel=true;this.cancel();if(globalShortcut.isRegistered("Escape"))globalShortcut.unregister("Escape");if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_CHANGE_WINDOW,null,Common.LINE_WINDOW)});Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Starting select line......");this.mLineHead.handle(urlStr,changeLine)};
LineHandlerController.prototype.initEvent=function(){ECEvent.on(Common.EVENT_SELECT_LINE_SUCCESSFULLY,(urlStr)=>{Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Received ec_event: "+Common.EVENT_SELECT_LINE_SUCCESSFULLY);Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Event select_line_successfully! And the url is "+urlStr);if(this.mIsCancel)return;if(globalShortcut.isRegistered("Escape"))globalShortcut.unregister("Escape");var urlObj=Url.parse(urlStr);gAuthInfo["authUrl"]=urlObj.protocol+"//"+urlObj.hostname;
if(urlObj["port"]!=null&&urlObj["port"]!=="443")gAuthInfo["authUrl"]+=":"+urlObj.port;Log.info(Common.LOG_LINE_CONTROLLER_TAG,"The authUrl is "+gAuthInfo["authUrl"]);if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_SELECT_LINE_SUCCESSFULLY);Log.debug(Common.LOG_LINE_CONTROLLER_TAG,"change from "+gCurrState+" to "+Common.STATE_INITIALIZING);gCurrState=Common.STATE_INITIALIZING;if(gControllers.httpsCom==null){gControllers["httpsCom"]=new HttpsComController;gControllers["httpsCom"].init()}else ECEvent.emit(Common.EVENT_HTTPS_INIT_OK)});
ECEvent.on(Common.EVENT_SELECT_LINE_ERROR,(error)=>{Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Received ec_event: "+Common.EVENT_SELECT_LINE_ERROR);if(this.mIsCancel)return;if(globalShortcut.isRegistered("Escape"))globalShortcut.unregister("Escape");switch(error){case Common.LINE_ERROR_CODE_URL_EMPTY:Log.warning(Common.LOG_LINE_CONTROLLER_TAG,"The url is empty!");break;case Common.LINE_ERROR_CODE_NOT_CONN:Log.warning(Common.LOG_LINE_CONTROLLER_TAG,"Cannot connect the server!");break;case Common.LINE_ERROR_CODE_NOT_ADDR:Log.warning(Common.LOG_LINE_CONTROLLER_TAG,
"Cannot find the addr!");break;default:Log.warning(Common.LOG_LINE_CONTROLLER_TAG,"Cannot understand the select line error code: "+error)}ECUtil.showMessageBox(null,{type:"warning",title:ECI18n("Alert"),message:ECI18n("Failed to connect to server. Please check whether the network works well.")});if(gECWindow!=null&&!gIsExited)gECWindow.getWebContents().send(Common.EVENT_MAIN_SELECT_LINE_ERROR,error)});ECEvent.on(Common.EVENT_SELECT_LINE_AGAIN,(urlStr,changeLine)=>{if(urlStr==null||urlStr===""){Log.warning(Common.LOG_LINE_CONTROLLER_TAG,
"The urlStr is null!");return}Log.info(Common.LOG_LINE_CONTROLLER_TAG,"The url: "+urlStr+" is not https addr, and need to select line again!");this.startSelectLine(urlStr,changeLine)});ECEvent.on(Common.EVENT_CHANGE_LINE,(lineLink)=>{Log.debug(Common.LOG_LINE_CONTROLLER_TAG,"Received ec_event: "+Common.EVENT_CHANGE_LINE+" lineLink: "+lineLink);gAuthInfo["authUrl"]=lineLink})};
LineHandlerController.prototype.initLineHandler=function(){Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Starting initializing LineHandler...");var webAgentHandler=new WebAgentHandler;var multiLineHandler=new MultiLineHandler;webAgentHandler.setNextLineHandler(multiLineHandler);this.mLineHead=webAgentHandler;Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Initialize LineHandler successfully!")};
LineHandlerController.prototype.initIPCMain=function(){Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Starting initializing ipcMain_event...");ipcMain.on(Common.EVENT_RENDER_START_SELENT_LINE,(event,urlStr)=>{Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Received ipcMain_event: "+Common.EVENT_RENDER_START_SELENT_LINE);gAuthInfo["selectLineUrl"]=urlStr;this.startSelectLine(urlStr)});ipcMain.on(Common.EVENT_IPCRENDER_DELETE_LINE,(event,line)=>{Log.debug(Common.LOG_LINE_CONTROLLER_TAG,"Received ipcrender_event: "+
Common.EVENT_IPCRENDER_DELETE_LINE);gControllers.conf.deleteUrl(line);gControllers.conf.save()});Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Initialize ipcMain_event successfully!")};LineHandlerController.prototype.cancel=function(){Log.info(Common.LOG_LINE_CONTROLLER_TAG,"Cancle selecting line!");var node=this.mLineHead;while(node!=null){node.cancel();node=node.mNextLineHandler}};module.exports=LineHandlerController;
