'use strict';const Https=require("https");const QueryString=require("querystring");const Url=require("url");const FS=require("fs");const Path=require("path");const Common=require("../../common");const Authentication=require("./authentication");const Log=require("../lib/ec_log");const ECEvent=require("../lib/ec_event");const ECUtil=require("../lib/ec_util");function CertAuth(){this.mAuthType=Common.AUTH_CERT}CertAuth.prototype=new Authentication;
CertAuth.prototype.doRequestAuth=function(urlStr,argObj){if(argObj==null){Log.warning(this.getLogTag(),"CertAuth argObj is null!");return}Cookies.get({url:gAuthInfo["authUrl"]},(error,cookies)=>{if(error){Log.warning(this.getLogTag(),"Get cookies error!");return}var cookiesStrArray=new Array;for(var i=0;i<cookies.length;++i){var cookieStr=cookies[i]["name"]+"\x3d"+cookies[i]["value"];cookiesStrArray[i]=cookieStr}var cookiesStr=cookiesStrArray.join("; ");argObj["arg3"]=cookiesStr;Log.info(this.getLogTag(),
"Starting cert auth...");ECEvent.once(Common.EVENT_CERT_AUTH_RESULT,(resStr)=>{Log.debug(this.getLogTag(),"Received ec_event: "+Common.EVENT_CERT_AUTH_RESULT);this.parseResult(resStr)});argObj["callback"]=Common.CERT_AUTH_CALLBACK;gControllers["httpsCom"].requestECAgent("CertAuth",argObj)})};
CertAuth.prototype.parseResult=function(resStr){if(resStr==null||""===resStr){Log.warning(this.getLogTag(),"The resStr is null");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}var resObj=JSON.parse(resStr);if(!("result"in resObj)){Log.warning(this.getLogTag(),"result is null");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}const xml2js=require("../../node_modules/xml2js");var parser=new xml2js.Parser;parser.parseString(resObj["result"],(err,
result)=>{if(err){Log.debug(this.getLogTag(),"parseString error: "+err);this.parseNoXMLResult(resObj);return}if("message"in resObj){var cookiesArray=resObj["message"].split(",");if(cookiesArray.length>0)ECUtil.parseSetCookies(cookiesArray)}Log.debug(this.getLogTag(),JSON.stringify(result));var resultObj={};try{resultObj["result"]=result["Auth"]["Result"][0];resultObj["enableMAM"]=result["Auth"]["EnableMAM"][0]=="1";resultObj["suportMDM"]=result["Auth"]["SuportMDM"][0]=="1";resultObj["curAuth"]=result["Auth"]["CurAuth"][0];
resultObj["nextAuth"]=result["Auth"]["NextAuth"][0];resultObj["authInfo"]=result["Auth"]["AuthInfo"][0];resultObj["note"]=result["Auth"]["Note"][0];resultObj["challengeMsg"]=result["Auth"]["ChallengeMsg"][0];resultObj["smsIsStillValid"]=parseInt(result["Auth"]["SmsIsStillValid"][0],10);resultObj["phone"]=result["Auth"]["Phone"][0];resultObj["curPhone"]=result["Auth"]["CurPhone"][0];ECEvent.emit(Common.EVENT_AUTH_RESULT,JSON.stringify(resultObj));Log.info(this.getLogTag(),"End of "+this.getLogTag())}catch(e){Log.warning(this.getLogTag(),
"parseResult error: "+e)}})};
CertAuth.prototype.parseNoXMLResult=function(resObj){Log.debug(this.getLogTag(),"parseNoXMLResult: "+JSON.stringify(resObj));if(!("result"in resObj)){Log.warning(this.getLogTag(),"result is null");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}if("message"in resObj)Log.info(this.getLogTag(),"CertAuth error: "+resObj["message"]);Log.debug(this.getLogTag(),"Sending ec_event: "+Common.EVENT_CERT_AUTH_ERROR);ECEvent.emit(Common.EVENT_CERT_AUTH_ERROR,resObj["result"])};
CertAuth.prototype.getLogTag=function(){return Common.LOG_CERT_AUTH_TAG};module.exports=CertAuth;
