'use strict';const Https=require("https");const QueryString=require("querystring");const Url=require("url");const FS=require("fs");const Path=require("path");const Common=require("../../common");const Authentication=require("./authentication");const Log=require("../lib/ec_log");const ECEvent=require("../lib/ec_event");
function HardIDAuth(type){this.mAuthType=Common.HARDWARE_ID_AUTH;if(type==null||type==="")this.mHardIDType=Common.HARDWARE_ID_AUTH_GETTYPE;else this.mHardIDType=type;this.mStartWithGetType=false;if(this.mHardIDType===Common.HARDWARE_ID_AUTH_GETTYPE)this.mStartWithGetType=true}HardIDAuth.prototype=new Authentication;
HardIDAuth.prototype.doRequestAuth=function(urlStr,argObj){if(null==urlStr||urlStr.length<=0){Log.warning(this.getLogTag(),"urlStr is null!");if(typeof gAuthInfo["authUrl"]!="undefined"&&gAuthInfo["authUrl"]!=null)urlStr=gAuthInfo["authUrl"];else return}Log.info(this.getLogTag(),"Starting hard id auth......");var urlPath;switch(this.mHardIDType){case Common.HARDWARE_ID_AUTH_GETTYPE:urlPath=Common.HARD_ID_AUTH_GETTYPE_URL;break;case Common.HARD_ID_AUTH_COLLECTION:urlPath=Common.HARD_ID_AUTH_COLLECT_URL;
break;case Common.HARD_ID_AUTH_AUTH:urlPath=Common.HARD_ID_AUTH_URL;break;default:Log.warning(this.getLogTag(),"hard_id_auth_type error: "+this.mHardIDType);return}urlStr+=urlPath+this.getUrlSuffix();Log.debug(Common.LOG_HARD_ID_AUTH_TAG,urlStr);var postDataObj={};if(typeof argObj!=="undefined"&&argObj!=null)postDataObj=argObj;var postData=QueryString.stringify(postDataObj);var urlObj=Url.parse(urlStr);const options={hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"POST",rejectUnauthorized:false,
headers:{"Content-Type":"application/x-www-form-urlencoded","Content-Length":Buffer.byteLength(postData)}};this.doPostRequest(options,postData)};
HardIDAuth.prototype.parseResult=function(xmlStr){if(xmlStr==null||""==xmlStr){Log.warning(this.getLogTag(),"The xmlStr is null!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}const xml2js=require("../../node_modules/xml2js");var parser=new xml2js.Parser;if(this.mHardIDType==Common.HARDWARE_ID_AUTH_GETTYPE){Log.info(this.getLogTag(),"Parsing hard id gettype result!");parser.parseString(xmlStr,(err,result)=>{if(err){Log.warning(this.getLogTag(),"parseString error: "+
err);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_ERROR);return}Log.debug(Common.LOG_AUTHENTICATION_TAG,JSON.stringify(result));this.mHardIDType=result["Auth"]["Result"][0];this.doRequestAuth(gAuthInfo["authUrl"],gAuthInfo["hardID"])});return}Log.info(this.getLogTag(),"Parsing hard id auth result!");parser.parseString(xmlStr,(err,result)=>{if(err){Log.warning(this.getLogTag(),"parseString error: "+err);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_ERROR);return}Log.debug(this.getLogTag(),
JSON.stringify(result));var resObj={};if(this.mHardIDType===Common.HARD_ID_AUTH_AUTH){resObj["result"]=result["Auth"]["Result"][0];resObj["enableMAM"]=result["Auth"]["EnableMAM"][0]=="1";resObj["suportMDM"]=result["Auth"]["SuportMDM"][0]=="1";resObj["curAuth"]=result["Auth"]["CurAuth"][0];resObj["nextAuth"]=result["Auth"]["NextAuth"][0];resObj["authInfo"]=result["Auth"]["AuthInfo"][0];resObj["note"]=result["Auth"]["Note"][0];resObj["challengeMsg"]=result["Auth"]["ChallengeMsg"][0];resObj["smsIsStillValid"]=
parseInt(result["Auth"]["SmsIsStillValid"][0],10);resObj["phone"]=result["Auth"]["Phone"][0];resObj["curPhone"]=result["Auth"]["CurPhone"][0];if(resObj["phone"]!=null&&resObj["phone"]!=="")gAuthInfo["phone"]=resObj["phone"];ECEvent.emit(Common.EVENT_AUTH_RESULT,JSON.stringify(resObj))}else{resObj["result"]=result["Auth"]["Result"][0];resObj["note"]=result["Auth"]["Note"][0];resObj["startWithGetType"]=this.mStartWithGetType;Log.debug(this.getLogTag(),"Sending ec_event: "+Common.EVENT_HARD_ID_COLLECTION_RESULT);
ECEvent.emit(Common.EVENT_HARD_ID_COLLECTION_RESULT,JSON.stringify(resObj))}})};HardIDAuth.prototype.getLogTag=function(){return Common.LOG_HARD_ID_AUTH_TAG};module.exports=HardIDAuth;
