'use strict';const Https=require("https");const QueryString=require("querystring");const Url=require("url");const FS=require("fs");const Path=require("path");const Common=require("../../common");const Authentication=require("./authentication");const Log=require("../lib/ec_log");const ECEvent=require("../lib/ec_event");function PreAuth(){this.mAuthType=Common.PRE_AUTH}PreAuth.prototype=new Authentication;
PreAuth.prototype.doRequestAuth=function(urlStr){if(urlStr==null||""===urlStr){Log.warning(this.getLogTag(),"urlStr is null!");if(typeof gAuthInfo["authUrl"]!="undefined"&&gAuthInfo["authUrl"]!=null)urlStr=gAuthInfo["authUrl"];else return}Log.info(this.getLogTag(),"Starting pre auth......");urlStr+=Common.PRE_AUTH_URL+this.getUrlSuffix();Log.debug(this.getLogTag(),urlStr);var urlObj=Url.parse(urlStr);var options={hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"POST",rejectUnauthorized:false};
this.doPostRequest(options)};
PreAuth.prototype.parseResult=function(xmlStr){if(xmlStr==null||""==xmlStr){Log.warning(this.getLogTag(),"The xmlStr is null!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}const xml2js=require("../../node_modules/xml2js");var parser=new xml2js.Parser;parser.parseString(xmlStr,(err,result)=>{if(err){Log.warning(this.getLogTag(),"Parse xmlStr error!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_ERROR);return}Log.debug(this.getLogTag(),JSON.stringify(result));
if(!("gPreAuth"in global)||typeof global["gPreAuth"]!=="object")global["gPreAuth"]={};if(typeof result==="undefined"||!("Auth"in result)){Log.error(this.getLogTag(),"PreAuth Result error: the result does not have Auth!");return}var authRes=result["Auth"];if(typeof authRes==="undefined"||!("StartAuth"in authRes)){Log.error(this.getLogTag(),"PreAuth Result error: !");return}try{if(authRes["StartAuth"]instanceof Array)gPreAuth["startAuth"]=authRes["StartAuth"][0];if(authRes["TwfID"]instanceof Array)gPreAuth["twfID"]=
authRes["TwfID"][0];if(authRes["RndImg"]instanceof Array)gPreAuth["rndImg"]=authRes["RndImg"][0]=="1";if(authRes["Anonymous"]instanceof Array)gPreAuth["anonymous"]=authRes["Anonymous"][0]=="1";if(authRes["Deny_normal_user"]instanceof Array)gPreAuth["denyNormalUser"]=authRes["Deny_normal_user"][0]=="1";if(authRes["Autoinstall"]instanceof Array)gPreAuth["autoInstall"]=authRes["Autoinstall"][0]=="1";if(authRes["Softkey"]instanceof Array)gPreAuth["softKey"]=authRes["Softkey"][0]=="1";if(authRes["enablesavepwd"]instanceof
Array)gPreAuth["enableSavePwd"]=authRes["enablesavepwd"][0]=="1";if(authRes["enableautologin"]instanceof Array)gPreAuth["enableAutoLogin"]=authRes["enableautologin"][0]=="1";if(authRes["enableautoRelogin"]instanceof Array)gPreAuth["enableAutoRelogin"]=authRes["enableautoRelogin"][0]=="1";if(authRes["enablethirdpartycert"]instanceof Array)gPreAuth["enableThirdPartyCert"]=authRes["enablethirdpartycert"][0]=="1";if(authRes["certcodetype"]instanceof Array)gPreAuth["certCodeType"]=authRes["certcodetype"][0];
if(authRes["Is_enable_mult_client"]instanceof Array)gPreAuth["isEnableMultClient"]=authRes["Is_enable_mult_client"][0]=="1";if(authRes["Mult_client_guid"]instanceof Array)gPreAuth["multClientGuid"]=authRes["Mult_client_guid"][0];if(authRes["RSA_ENCRYPT_KEY"]instanceof Array)gPreAuth["rsaEncryptKey"]=authRes["RSA_ENCRYPT_KEY"][0];if(authRes["RSA_ENCRYPT_EXP"]instanceof Array)gPreAuth["rsaEncryptExp"]=authRes["RSA_ENCRYPT_EXP"][0];else gPreAuth["rsaEncryptExp"]=parseInt("65537").toString(16);if(authRes["RESET_PASSWORD"]instanceof
Array)gPreAuth["resetPsw"]=authRes["RESET_PASSWORD"][0]=="1";if(authRes["AllowBindSms"]instanceof Array)gPreAuth["allowBindSms"]=authRes["AllowBindSms"][0]=="1";Log.debug(this.getLogTag(),JSON.stringify(authRes))}catch(e){Log.warning(this.getLogTag(),"Parse pre_auth result error: "+e);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_ERROR);return}ECEvent.emit(Common.EVENT_PRE_AUTH_RESULT,JSON.stringify(gPreAuth))})};PreAuth.prototype.getLogTag=function(){return Common.LOG_PRE_AUTH_TAG};
module.exports=PreAuth;
