'use strict';const Https=require("https");const QueryString=require("querystring");const Url=require("url");const FS=require("fs");const Path=require("path");const Common=require("../../common");const Authentication=require("./authentication");const Log=require("../lib/ec_log");const ECEvent=require("../lib/ec_event");function SmsAuth(){this.mAuthType=Common.SMS_AUTH;this.mNeedLoadUrl=true;this.mSubType=null}SmsAuth.prototype=new Authentication;
SmsAuth.prototype.doRequestAuth=function(urlStr,argObj){if(null==urlStr||urlStr.length<=0){Log.debug(this.getLogTag(),"The urlStr is null!");if(typeof gAuthInfo["authUrl"]!="undefined"&&gAuthInfo["authUrl"]!=null)urlStr=gAuthInfo["authUrl"];else return}this.mNeedLoadUrl=false;var postDataObj={};var isRegetSms=false;if(argObj==null||argObj==={}){urlStr+=Common.SMS_AUTH_REGET_URL+this.getUrlSuffix();isRegetSms=true;this.mSubType=Common.SMS_REGET}else if(Common.SMS_PHONE_REGET_CODE in argObj){urlStr+=
Common.SMS_AUTH_REGET_PHONE_URL+this.getUrlSuffix();postDataObj[Common.SMS_PHONE]=argObj[Common.SMS_PHONE_REGET_CODE];this.mSubType=Common.SMS_PHONE_REGET}else if(Common.SMS_AUTH_CODE in argObj){urlStr+=Common.SMS_AUTH_URL+this.getUrlSuffix();postDataObj[Common.SMS_AUTH_CODE]=argObj[Common.SMS_AUTH_CODE];this.mSubType=Common.SMS_SUBMIT_CODE}else if(Common.SMS_PHONE in argObj){urlStr+=Common.SMS_SUBMIT_PHONE_URL+this.getUrlSuffix();postDataObj[Common.SMS_PHONE]=argObj[Common.SMS_PHONE];this.mSubType=
Common.SMS_SUBMIT_PHONE}else if(Common.SMS_BOUND_PHONE_CODE in argObj){urlStr+=Common.SMS_BOUND_PHONE_URL+this.getUrlSuffix();postDataObj[Common.SMS_AUTH_CODE]=argObj[Common.SMS_BOUND_PHONE_CODE];this.mSubType=Common.SMS_BOUND_PHONE}else Log.warning(this.getLogTag(),"The argObj is "+JSON.stringify(argObj));Log.debug(this.getLogTag(),urlStr);var postData=QueryString.stringify(postDataObj);var urlObj=Url.parse(urlStr);var options={hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"POST",
rejectUnauthorized:false,headers:{"Content-Type":"application/x-www-form-urlencoded","Content-Length":Buffer.byteLength(postData)}};this.doPostRequest(options,postData);if(isRegetSms)setTimeout(()=>{this.getSmsPage(gAuthInfo["authUrl"],this.mNeedLoadUrl)},Common.SMS_GET_PAGE_TIMEOUT)};
SmsAuth.prototype.regetSmsCode=function(urlStr){if(null==urlStr||urlStr.length<=0){Log.debug(this.getLogTag(),"The urlStr is null!");if(typeof gAuthInfo["authUrl"]!="undefined"&&gAuthInfo["authUrl"]!=null)urlStr=gAuthInfo["authUrl"];else return}var urlStrReget=urlStr+Common.SMS_AUTH_REGET_URL+this.getUrlSuffix();Log.debug(this.getLogTag(),urlStrReget);var urlObj=Url.parse(urlStrReget);var options={hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"POST",rejectUnauthorized:false};this.doPostRequest(options)};
SmsAuth.prototype.getSmsPage=function(urlStr,needLoadUrl){if(null==urlStr||urlStr.length<=0){Log.debug(this.getLogTag(),"The urlStr is null!");if(typeof gAuthInfo["authUrl"]!="undefined"&&gAuthInfo["authUrl"]!=null)urlStr=gAuthInfo["authUrl"];else return}if(needLoadUrl===true)this.mNeedLoadUrl=true;else this.mNeedLoadUrl=false;urlStr+=Common.SMS_PAGE_URL;Log.debug(this.getLogTag(),urlStr);var urlObj=Url.parse(urlStr);const options={hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"GET",
rejectUnauthorized:false};this.doPostRequest(options)};
SmsAuth.prototype.parseNoXMLResult=function(resStr){if(null==resStr||resStr.length<=0){Log.warning(this.getLogTag(),"The resStr is null!");ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_EMPTY);return}if(resStr.length<Common.SMS_REGET_RESULT_MAX_LENGTH){ECEvent.emit(Common.EVENT_REGET_SMS_CODE_RESULT,resStr.trim());return}var pattern=new RegExp(Common.SMS_AUTH_DISABLE_TIME,"g");var matches=pattern.exec(resStr);if(null==matches)Log.warning(this.getLogTag(),"Can not find the sms disable time!");
var smsDisableTime=0;try{smsDisableTime=parseInt(matches[4],10)}catch(e){Log.warning(this.getLogTag(),"Get smsDisableTime error: "+e);smsDisableTime=0}Log.info(this.getLogTag(),"The sms disable time is "+smsDisableTime);ECEvent.emit(Common.EVENT_GET_SMS_PAGE_RESULT,smsDisableTime,this.mNeedLoadUrl)};
SmsAuth.prototype.parseSubResult=function(xmlObj){var resObj={};try{resObj["result"]=xmlObj["Auth"]["Result"][0];resObj["note"]=xmlObj["Auth"]["Note"][0];resObj["smsIsStillValid"]=parseInt(xmlObj["Auth"]["SmsIsStillValid"][0],10);resObj["type"]=this.mSubType;ECEvent.emit(Common.EVENT_SUBMIT_PHONE_RESULT,JSON.stringify(resObj))}catch(e){Log.warning(this.getLogTag(),"parseSubResult error: "+e);ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_RESPONE_DATA_ERROR)}};SmsAuth.prototype.getLogTag=function(){return Common.LOG_SMS_AUTH_TAG};
module.exports=SmsAuth;
