'use strict';const Path=require("path");const FS=require("fs");const Common=require("../../common");const Log=require("./ec_log");const ECEvent=require("./ec_event");function Configuration(){this.mIsInit=false;this.mConfJson=null}
Configuration.prototype.init=function(){Log.info(Common.LOG_CONFIGURATION_TAG,"Starting initializing Configuration module!");if(!FS.existsSync(Common.CONF_PATH)){ECEvent.emit("conf_error","The conf file does not exit!");this.mIsInit=false}else{var confStr=null,confFile=null;confFile=Common.CONF_PATH;Log.info(Common.LOG_CONFIGURATION_TAG,"Conf file is "+confFile);try{confStr=FS.readFileSync(confFile,"utf8");this.mConfJson=JSON.parse(confStr);if(this.mConfJson==null)this.mIsInit=false;else{var defaultConfJSON=
JSON.parse(FS.readFileSync(Common.DEFAULT_CONF_PATH,"utf8"));if(!("version"in this.mConfJson)||!this.cmpVer(this.mConfJson["version"],defaultConfJSON["version"])){for(var i=0;i<this.mConfJson["vpn_servers"].length;++i){var line=this.mConfJson["vpn_servers"][i];if(line in this.mConfJson){defaultConfJSON[line]=this.mConfJson[line];defaultConfJSON["vpn_servers"].push(line);for(var key in defaultConfJSON["default"])if(!(key in defaultConfJSON[line]))defaultConfJSON[line][key]=defaultConfJSON["default"][key]}}this.mConfJson=
JSON.parse(JSON.stringify(defaultConfJSON))}}this.mIsInit=true}catch(e){Log.error(Common.LOG_CONFIGURATION_TAG,"The content of conf file is null");ECEvent.emit("conf_error","Parse the conf error");this.mIsInit=false}if(this.mConfJson==null){Log.error(Common.LOG_CONFIGURATION_TAG,"Fail to parse the conf file!");ECEvent.emit("conf_error","Fail to parse the conf file!");this.mIsInit=false}if(this.mIsInit&&this.mConfJson!=null)if(!this.checkConf()){Log.error(Common.LOG_CONFIGURATION_TAG,"The conf is incomplete!");
ECEvent.emit("conf_error","Can not find the default conf!");this.mIsInit=false}}if(!this.mIsInit)if(!FS.existsSync(Common.DEFAULT_CONF_PATH))Log.error(Common.LOG_CONFIGURATION_TAG,"The default conf file "+Common.DEFAULT_CONF_PATH+" does not exist!");else{Log.info(Common.LOG_CONFIGURATION_TAG,"Read the default conf file: "+Common.DEFAULT_CONF_PATH);var defConfStr=FS.readFileSync(Common.DEFAULT_CONF_PATH,"utf8");try{this.mConfJson=JSON.parse(defConfStr);this.mIsInit=true}catch(e){Log.error(Common.LOG_CONFIGURATION_TAG,
"The content of default conf file is null");this.mIsInit=false}}if(this.mConfJson!=null)Log.debug(Common.LOG_CONFIGURATION_TAG,JSON.stringify(this.mConfJson));else Log.debug(Common.LOG_CONFIGURATION_TAG,"The conf is null");Log.info(Common.LOG_CONFIGURATION_TAG,"The Configuration module initialized succeffully!")};Configuration.prototype.getLines=function(){if(this.mConfJson!=null&&"vpn_servers"in this.mConfJson)return this.mConfJson["vpn_servers"];else return[]};
Configuration.prototype.checkConf=function(){if(!("language"in this.mConfJson))return false;if(!("last_check_update_time"in this.mConfJson))return false;if(!("force_update"in this.mConfJson))return false;if(!("vpn_servers"in this.mConfJson))return false;if(!("default"in this.mConfJson))return false;return true};
Configuration.prototype.get=function(key){Log.debug(Common.LOG_CONFIGURATION_TAG,"Get key ["+key+"] of the current url!");if(gAuthInfo["selectLineUrl"]==null||this.mConfJson==null){Log.warning(Common.LOG_CONFIGURATION_TAG,"gAuthInfo.selectLineUrl or this.mConfJson is null!");return null}return this.getUrl(gAuthInfo["selectLineUrl"],key)};
Configuration.prototype.getUrl=function(url,key){if(this.mConfJson==null){Log.warning(Common.LOG_CONFIGURATION_TAG,"getUrl: this.mConfJson is null!");return null}Log.debug(Common.LOG_CONFIGURATION_TAG,"Get key ["+key+"] of url: "+url);if(url==null)if(key in this.mConfJson)return this.mConfJson[key];else return null;if(!(url in this.mConfJson))this.addUrl(url);if(key in this.mConfJson[url])return this.mConfJson[url][key];else{Log.warning(Common.LOG_CONFIGURATION_TAG,"The key ["+key+"] of "+gAuthInfo.selectLineUrl+
" does not exit!");return null}};Configuration.prototype.set=function(key,value){Log.debug(Common.LOG_CONFIGURATION_TAG,"Set key ["+key+"] of the current url to "+value);if(gAuthInfo["selectLineUrl"]==null||this.mConfJson==null){Log.warning(Common.LOG_CONFIGURATION_TAG,"gAuthInfo.selectLineUrl or this.mConfJson is null!");return}this.setUrl(gAuthInfo["selectLineUrl"],key,value)};
Configuration.prototype.setUrl=function(url,key,value){if(this.mConfJson==null){Log.warning(Common.LOG_CONFIGURATION_TAG,"setUrl: this.mConfJson is null!");return}Log.debug(Common.LOG_CONFIGURATION_TAG,"Set key ["+key+"] of "+url+" to "+value);if(url==null){if(key in this.mConfJson)this.mConfJson[key]=value;return}if(!(url in this.mConfJson))this.addUrl(url);if(key in this.mConfJson[url])this.mConfJson[url][key]=value};
Configuration.prototype.save=function(){if(!this.mIsInit){Log.warning(Common.LOG_CONFIGURATION_TAG,"The conf has not been initialized, cannot be saved.");return}Log.info(Common.LOG_CONFIGURATION_TAG,"Save Conf ......");FS.writeFile(Common.CONF_PATH,JSON.stringify(this.mConfJson,null,4),"utf8",(err)=>{if(err)Log.error(Common.LOG_CONFIGURATION_TAG,"Fail to save the conf file!");Log.info(Common.LOG_CONFIGURATION_TAG,"The conf file was saved succeffully!")})};
Configuration.prototype.addUrl=function(url){if(url==null||url===""){Log.warning(Common.LOG_CONFIGURATION_TAG,"The added url is null!");return}if(!this.mIsInit){Log.warning(Common.LOG_CONFIGURATION_TAG,"The conf is not initialized!");return}Log.info(Common.LOG_CONFIGURATION_TAG,"Add url ("+url+").");if(!("vpn_servers"in this.mConfJson))this.mConfJson["vpn_servers"]=new Array;if(url in this.mConfJson){for(var i=0;i<this.mConfJson["vpn_servers"].length;++i)if(this.mConfJson["vpn_servers"][i]===url)this.mConfJson["vpn_servers"].splice(i,
1);this.mConfJson["vpn_servers"].push(url);return}this.mConfJson["vpn_servers"].push(url);this.mConfJson[url]=this.copyDefault();if(this.mConfJson["vpn_servers"].length>Common.MAX_CONF_LEN)this.deleteUrl(this.mConfJson["vpn_servers"][0])};
Configuration.prototype.deleteUrl=function(url){if(url==null||this.mConfJson==null||!(url in this.mConfJson)){Log.warning(Common.LOG_CONFIGURATION_TAG,"The url ("+url+") does not exist!");return}Log.info(Common.LOG_CONFIGURATION_TAG,"Delete url ("+url+").");for(var i=0;i<this.mConfJson["vpn_servers"].length;++i)if(this.mConfJson["vpn_servers"][i]===url)this.mConfJson["vpn_servers"].splice(i,1);delete this.mConfJson[url]};
Configuration.prototype.copyDefault=function(){if(this.mConfJson==null||!("default"in this.mConfJson)){Log.warning(Common.LOG_CONFIGURATION_TAG,"The conf of default is null!");return null}return JSON.parse(JSON.stringify(this.mConfJson["default"]))};
Configuration.prototype.cmpVer=function(curVer,defVer){if(curVer==null)return false;if(defVer==null)return true;Log.info(Common.LOG_CONFIGURATION_TAG,"Compare(curVer: "+curVer+" defVer: "+defVer+")");var curVerArray=curVer.split(".");var defVerArray=defVer.split(".");var maxLen=curVerArray.length>defVerArray.length?curVerArray.length:defVerArray.length;for(var i=0;i<maxLen;++i){var curInt=0,defInt=0;if(curVerArray[i]!=null)try{curInt=parseInt(curVerArray[i]);if(isNaN(curInt))curInt=0}catch(e){curInt=
0}if(defVerArray[i]!=null)try{defInt=parseInt(defVerArray[i]);if(isNaN(defInt))defInt=0}catch(e){defInt=0}Log.info(Common.LOG_CONFIGURATION_TAG,"curInt: "+curInt+" defInt: "+defInt);if(curInt!==defInt)return false}return true};module.exports=Configuration;
