'use strict';const {net}=require("electron");const Path=require("path");const FS=require("fs");const Https=require("https");const Log=require("./ec_log");const Common=require("../../common");const ECEvent=require("./ec_event");
function HttpsCom(port,host,protocol,id){this.mPort=port?port:Common.HTTPS_DEFAULT_PORT;this.mHost=host?host:Common.HTTPS_DEFAULT_IP;this.mID=id?id:Common.HTTPS_DEFAULT_ID;this.mProtocol=protocol?protocol:Common.HTTPS_DEFAULT_PROTOCOL;this.mInitState=Common.HTTPS_UN_INIT;this.mTryTimes=0;this.mTimeoutWhiteList=new Set(["QUERY LOGOUT","QUERY TRAYSTAT","QUERY MESSAGES","QUERY QSTATE ALLSERVICES","QUERY QSTATE L3VPN"]);this.mLogBlackList={"QUERY LOGOUT":0,"QUERY TRAYSTAT":0,"QUERY MESSAGES":0}}
HttpsCom.prototype.init=function(){Log.info(Common.LOG_HTTPS_COM_TAG,"Starting initializing HttpsCom...");this.mPort=Common.HTTPS_DEFAULT_PORT;this.checkECAgentPortPath=false;this.mInitState=Common.HTTPS_UN_INIT;Log.info(Common.LOG_HTTPS_COM_TAG,"The times to init ECAgent: "+(this.mTryTimes+1));this.initECAgent()};
HttpsCom.prototype.initECAgent=function(args){Log.info(Common.LOG_HTTPS_COM_TAG,"testing port:"+this.mPort);var urlPath="/"+this.mID+"?"+"op\x3dInitECAgent";Log.info(Common.LOG_HTTPS_COM_TAG,"GetRequest "+urlPath);const request=Https.request({hostname:this.mHost,protocol:this.mProtocol,port:this.mPort,path:urlPath,rejectUnauthorized:false});var reqTimer=setTimeout(()=>{Log.info(Common.LOG_HTTPS_COM_TAG,"Request ECAgent timeout");request.abort();reqTimer=null},Common.HTTPS_REQUEST_ECAGENT_TIMEOUT);
request.on("error",(error)=>{Log.warning(Common.LOG_HTTPS_COM_TAG,"port:"+this.mPort+" cannot be accessed");if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(this.mPort===Common.HTTPS_DEFAULT_PORT+Common.HTTPS_PORT_PLUS_MAX_TIMES*Common.HTTPS_PORT_PLUS||this.checkECAgentPortPath)if(!this.checkECAgentPortPath&&FS.existsSync(Common.ECAGENT_PORT_PATH))try{var buf=FS.readFileSync(Common.ECAGENT_PORT_PATH);this.mPort=buf.readUInt16LE(0);Log.debug(Common.LOG_HTTPS_COM_TAG,"this.port: "+this.mPort);
this.checkECAgentPortPath=true;this.initECAgent()}catch(e){Log.warning(Common.LOG_HTTPS_COM_TAG,"Read "+Common.ECAGENT_PORT_PATH+" error: "+error);this.mTryTimes++;if(this.mTryTimes>=Common.HTTPS_MAX_RETRY_TIMES){this.mInitState=Common.HTTPS_INIT_ERROR;Log.error(Common.LOG_HTTPS_COM_TAG,"no port accessed");ECEvent.emit(Common.EVENT_HTTPS_INIT_ERROR)}else{this.mPort=Common.HTTPS_DEFAULT_PORT;this.checkECAgentPortPath=false;Log.info(Common.LOG_HTTPS_COM_TAG,"The times to init ECAgent: "+(this.mTryTimes+
1));var retryIntergval=this.mTryTimes*Common.HTTPS_RETRY_INITECAGENT_TIMEOUT;Log.debug(Common.LOG_HTTPS_COM_TAG,"The interval to retry is "+retryIntergval);setTimeout(()=>{this.initECAgent()},retryIntergval)}}else{this.mTryTimes++;if(this.mTryTimes>=Common.HTTPS_MAX_RETRY_TIMES){this.mInitState=Common.HTTPS_INIT_ERROR;Log.error(Common.LOG_HTTPS_COM_TAG,"no port accessed");ECEvent.emit(Common.EVENT_HTTPS_INIT_ERROR)}else{this.mPort=Common.HTTPS_DEFAULT_PORT;this.checkECAgentPortPath=false;Log.info(Common.LOG_HTTPS_COM_TAG,
"The times to init ECAgent: "+(this.mTryTimes+1));var retryIntergval=this.mTryTimes*Common.HTTPS_RETRY_INITECAGENT_TIMEOUT;Log.debug(Common.LOG_HTTPS_COM_TAG,"The interval to retry is "+retryIntergval);setTimeout(()=>{this.initECAgent()},retryIntergval)}}else{this.mPort+=Common.HTTPS_PORT_PLUS;this.initECAgent()}});request.once("response",(response)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}response.on("data",(chunk)=>{Log.debug(Common.LOG_HTTPS_COM_TAG,"InitECAgent result: "+chunk);
Log.info(Common.LOG_HTTPS_COM_TAG,"Init HttpsCom successfully, and the port is "+this.mPort);gECAgent["port"]=this.mPort;this.mInitState=Common.HTTPS_INIT_OK;this.mTryTimes=0;ECEvent.emit(Common.EVENT_HTTPS_INIT_OK)});response.on("end",()=>{})});request.end()};
HttpsCom.prototype.ECAgent=function(op,args,callback){if(this.mInitState!=Common.HTTPS_INIT_OK)return;if(typeof args!=="object")args={};var urlPath="/"+this.mID+"?"+"op\x3d"+op;var hex_md5=require("./md5");if("token"in args&&args["token"]!=null&&args["token"]!=="")args["token"]=hex_md5(args["token"]+Common.HTTPS_ECAGENT_MD5SALT);else if(gAuthInfo["currToken"]!=null&&gAuthInfo["currToken"]!=="")args["token"]=hex_md5(gAuthInfo["currToken"]+Common.HTTPS_ECAGENT_MD5SALT);if(gPreAuth["multClientGuid"]!=
null)args["Guid"]=gPreAuth["multClientGuid"];for(var key in args){var encodeKey="";var encodeValue="";if(key!=null)encodeKey=encodeURIComponent(key);if(encodeValue!=null)encodeValue=encodeURIComponent(args[key]);urlPath+="\x26"+encodeKey+"\x3d"+encodeValue}urlPath+="\x26type\x3dEC";if(args["arg1"]==="QUERY GETHARDID")op="HardIDAuth";var enableTimer=true;if(this.mTimeoutWhiteList.has(args["arg1"]))enableTimer=false;var enableLog=true;if(args["arg1"]in this.mLogBlackList){if(this.mLogBlackList[args["arg1"]]%
Common.LOG_PRINT_INTERVAL!==0)enableLog=false;else{enableLog=true;this.mLogBlackList[args["arg1"]]=0}this.mLogBlackList[args["arg1"]]++}if(op!=="ImportCert")if(enableLog)Log.info(Common.LOG_HTTPS_COM_TAG,"url: "+"https://"+this.mHost+":"+this.mPort+urlPath);this.doHttpsGetRequest(urlPath,callback,op,enableTimer,enableLog)};
HttpsCom.prototype.doCheckRelogin=function(reloginObj){if(this.mInitState!=Common.HTTPS_INIT_OK)return;var urlPath="/"+this.mID+"?"+"op\x3dCheckReLogin";for(var key in reloginObj)urlPath+="\x26"+key+"\x3d"+reloginObj[key];this.doHttpsGetRequest(this.enCodeURL(urlPath))};
HttpsCom.prototype.doConfigure=function(configureObj){if(this.mInitState!=Common.HTTPS_INIT_OK)return;if(!configureObj||typeof configureObj!=="object"){Log.warning({"tag":Common.LOG_HTTPS_COM_TAG,"filename":Path.basename(__filename),"lineNum":null,"content":"No doConfigure arguments!"});return}var urlPath="/"+this.mID+"?"+"op\x3ddoConfigure";for(var key in configureObj)urlPath+="\x26"+key+"\x3d"+configureObj[key];this.doHttpsGetRequest(this.enCodeURL(urlPath))};
HttpsCom.prototype.doQuerry=function(querryObj){if(this.mInitState!=Common.HTTPS_INIT_OK)return;if(!querryObj||typeof querryObj!=="object"){Log.warning(Common.LOG_HTTPS_COM_TAG,"No doQuerry arguments!");return}var urlPath="/"+this.mID+"?"+"op\x3dDoQueryService";for(var key in querryObj)urlPath+="\x26"+key+"\x3d"+querryObj[key];this.doHttpsGetRequest(this.enCodeURL(urlPath))};
HttpsCom.prototype.doLogout=function(logoutObj){if(this.mInitState!=Common.HTTPS_INIT_OK)return;var urlPath="/"+this.mID+"?"+"op\x3dLogout";for(var key in logoutObj)urlPath+="\x26"+key+"\x3d"+logoutObj[key];this.doHttpsGetRequest(this.enCodeURL(urlPath))};HttpsCom.prototype.enCodeURL=function(urlPath){return encodeURI(urlPath)};
HttpsCom.prototype.doHttpsGetRequest=function(urlPath,callback,op,enableTimer,enableLog){if(op!==Common.HTTPS_IMPORT_CERT&&enableLog)Log.info(Common.LOG_HTTPS_COM_TAG,"GetRequest "+urlPath);var timeoutTime=0;if(op===Common.HTTPS_IMPORT_CERT||op===Common.HTTPS_CERT_AUTH||op==="HardIDAuth"||op===Common.HTTPS_INIT_SERVER_CERT||op===Common.HTTPS_UPDATE_CONTROLS)timeoutTime=Common.HTTPS_REQUEST_ECAGENT_NEED_REQ_VPN_TIMEOUT;else timeoutTime=Common.HTTPS_REQUEST_ECAGENT_TIMEOUT;var request=Https.request({hostname:this.mHost,
protocol:this.mProtocol,port:this.mPort,path:urlPath,rejectUnauthorized:false,headers:{"User-Agent":"Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/51.0.2704.106 Safari/537.36"}});var reqTimer=null;if(enableTimer){if(op===Common.HTTPS_IMPORT_CERT)Log.debug(Common.LOG_HTTPS_COM_TAG,"enable timeout: "+timeoutTime+"ms");else Log.debug(Common.LOG_HTTPS_COM_TAG,"enable timeout "+urlPath+": "+timeoutTime+"ms");reqTimer=setTimeout(()=>{if(op===Common.HTTPS_IMPORT_CERT)Log.info(Common.LOG_HTTPS_COM_TAG,
"Request ECAgent timeout: ImportCert");else Log.info(Common.LOG_HTTPS_COM_TAG,"Request ECAgent timeout"+urlPath);request.abort();reqTimer=null},timeoutTime)}request.on("error",(error)=>{if(op===Common.HTTPS_IMPORT_CERT)Log.error(Common.LOG_HTTPS_COM_TAG,"doHttpsGetRequest error: "+error);else Log.error(Common.LOG_HTTPS_COM_TAG,"doHttpsGetRequest:"+urlPath+" error: "+error);if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(callback!=null&&"error"in callback)callback.error(error);else if(op===
Common.HTTPS_CERT_AUTH)ECEvent.emit(Common.EVENT_CERT_AUTH_ERROR,Common.AUTH_REQUEST_TIMEOUT);else if(op==="HardIDAuth")ECEvent.emit(Common.EVENT_AUTH_ERROR,Common.AUTH_REQUEST_ERROR);else if(op===Common.HTTPS_IMPORT_CERT)ECEvent.emit(Common.EVENT_IMPORT_CERT_RES,{result:Common.IMPORT_CERT_ERROR_TIMEOUT});else ECEvent.emit(Common.EVENT_HTTPS_GET_REQUEST_ERROR,JSON.stringify(error))});request.once("response",(response)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}var data=null;response.on("data",
(chunk)=>{if(data==null)data=chunk;else data+=chunk});response.on("end",()=>{if(enableLog)Log.debug(Common.LOG_HTTPS_COM_TAG,"end of http quest");if(callback!=null&&"ok"in callback)callback.ok(data);else{if(enableLog)Log.debug(Common.LOG_HTTPS_COM_TAG,"Sending ec_event: "+Common.EVENT_HTTPS_DATA+" data: "+data);ECEvent.emit(Common.EVENT_HTTPS_DATA,data.toString())}})});request.end()};
HttpsCom.prototype.parseData=function(chunk){var resStr=chunk.toString().trim();var f=resStr.indexOf("(");var l=resStr.lastIndexOf(")");var callback=resStr.slice(0,f);var subStr=resStr.slice(f+1,l);Log.debug(Common.LOG_HTTPS_COM_TAG,"callback: "+callback);Log.debug(Common.LOG_HTTPS_COM_TAG,"subStr: "+subStr);var resObj=JSON.parse(subStr);return resObj};module.exports=HttpsCom;
