'use strict';const Path=require("path");const Https=require("https");const Url=require("url");const Common=require("../../common");const Log=require("../lib/ec_log");const ECUtil=require("../lib/ec_util");const ECEvent=require("../lib/ec_event");function LineHandler(){this.mNextLineHandler=null;this.mIsCancel=false;this.mIsAlreadyChoose=false;this.mErrorTimes=0;this.mTimer=null;this.mLineLinksArray=[];this.mCurrLines=0;this.mIsChangeLine=false}
LineHandler.prototype.setNextLineHandler=function(handler){this.mNextLineHandler=handler};LineHandler.prototype.cancel=function(){this.mIsCancel=true;this.mIsHttpAddr=false};
LineHandler.prototype.handle=function(urlStr,changeLine){if(changeLine===Common.LINE_CHANGE_LINE){this.mIsChangeLine=true;var node=this.mNextLineHandler;while(node!=null){node.mIsChangeLine=true;node=node.mNextLineHandler}}if(null==urlStr||""===urlStr){if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_URL_EMPTY);return}var tmpUrl=urlStr;if(!ECUtil.isHttpAddr(urlStr)&&!ECUtil.isHttpsAddr(urlStr))tmpUrl=Common.PROTO_HTTP_HEAD+urlStr;try{Log.debug(Common.LOG_LINE_HANDLER_TAG,
"tmpUrl: "+tmpUrl);if(typeof Url.URL!=="undefined"||Url.URL!=null){var tmp=new Url.URL(tmpUrl);Log.debug(Common.LOG_LINE_HANDLER_TAG,"Check URl using url.URL!")}else{Log.debug(Common.LOG_LINE_HANDLER_TAG,"Check URl using regex!");if(!ECUtil.isURL(tmpUrl)){Log.warning(Common.LOG_LINE_HANDLER_TAG,"The url: "+urlStr+" is invalid. ");ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_URL_INVALID);return}}}catch(e){Log.warning(Common.LOG_LINE_HANDLER_TAG,"The url: "+urlStr+" is invalid. "+
e);ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_URL_INVALID);return}this.mIsCancel=false;if(ECUtil.isHttpsAddr(urlStr))this.requestDone(urlStr);else this.handleSelf(urlStr)};
LineHandler.prototype.handleSelf=function(urlStr){if(urlStr==null||urlStr===""){if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_URL_EMPTY);return}var tmpUrl=urlStr;if(!ECUtil.isHttpAddr(urlStr)&&!ECUtil.isHttpsAddr(urlStr)){tmpUrl=Common.PROTO_HTTP_HEAD+urlStr;this.mIsHttpAddr=true}else if(ECUtil.isHttpAddr(urlStr))this.mIsHttpAddr=true;if(this.mIsCancel)return;this.requestPageContent(tmpUrl)};
LineHandler.prototype.requestPageContent=function(urlStr){if(null==urlStr||""===urlStr)return;Log.info(this.getLogTag(),"requestPageContent: "+urlStr);var content="";var urlObj=Url.parse(urlStr);const options={protocol:urlObj.protocol,hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"GET",timeout:1E3,rejectUnauthorized:false};var HttpReq=require("http");if(urlObj.protocol=="https:")HttpReq=require("https");var request=HttpReq.request(options);global.reqTimer=setTimeout(()=>{Log.info(this.getLogTag(),
"requestPageContent timeout");request.abort();reqTimer=null},Common.SELECT_LINE_REQUEST_PAGE_TIMEOUT);request.on("error",(error)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(this.mIsCancel)return;Log.warning(this.getLogTag(),"requestPageContent error: "+error);if(ECUtil.isHttpsAddr(urlStr)||this.mIsHttpAddr){if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN)}else{urlStr=Common.PROTO_HTTPS_HEAD+urlStr.slice(7);this.requestPageContent(urlStr)}});
request.once("response",(response)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(this.mIsCancel)return;Log.debug(Common.LOG_LINE_HANDLER_TAG,"statusCode: "+response.statusCode);if(response.statusCode!==Common.HTTP_REQUEST_STATUS_OK&&response.statusCode!==Common.HTTP_REQUEST_STATUS_FOUND){if(ECUtil.isHttpsAddr(urlStr)||this.mIsHttpAddr){if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN)}else{urlStr=Common.PROTO_HTTPS_HEAD+
urlStr.slice(7);this.requestPageContent(urlStr)}return}Log.debug(this.getLogTag(),"headers: "+JSON.stringify(response.headers));content+=JSON.stringify(response.headers);response.on("data",(chunk)=>{content+=chunk.toString()});response.on("end",()=>{Log.info(this.getLogTag(),"Have received all data!");this.handleWithPageContent(response.headers,content)})});request.end()};
LineHandler.prototype.handleWithPageContent=function(headers,content){if(this.mIsCancel){Log.debug(this.getLogTag(),"cancelled!");return}if(null==content||""===content){if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN);return}Log.info(this.getLogTag(),"Handle the page content!");this.mLineLinksArray=this.getLines(headers,content);this.mCurrLines=0;if(this.mLineLinksArray!=null&&this.mLineLinksArray.length>0){Log.debug(this.getLogTag(),
"lineLinks: "+this.mLineLinksArray.toString());this.peekBestLine(this.mLineLinksArray[this.mCurrLines])}else if(null!=this.mNextLineHandler){Log.info(this.getLogTag(),"Select next line handler to work!");this.mNextLineHandler.handleWithPageContent(headers,content)}else{Log.info(this.getLogTag(),"The last handler selects line failed!");if(!this.mIsCancel&&!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_ADDR);return}};
LineHandler.prototype.peekBestLine=function(lineLinks){if(null==lineLinks||lineLinks.length==0||this.mIsCancel)return;if(lineLinks.length>1)this.selectBestLine(lineLinks);else{var lineLink=lineLinks[0];if(ECUtil.isHttpsAddr(lineLink)){if(!this.mIsCancel)this.requestDone(lineLink);return}ECEvent.emit(Common.EVENT_SELECT_LINE_AGAIN,lineLink,this.mIsChangeLine)}};
LineHandler.prototype.selectBestLine=function(lineLinks){if(null==lineLinks||lineLinks.length==0||this.mIsCancel)return;this.mIsAlreadyChoose=false;Log.info(this.getLogTag(),"Select the best line!");this.mTimer=setTimeout(()=>{if(this.mIsCancel)return;Log.warning(this.getLogTag(),"Request lineLinks timeout!");this.mCurrLines++;if(this.mCurrLines>=this.mLineLinksArray.length){this.mIsCancel=true;if(!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN)}else this.peekBestLine(this.mLineLinksArray[this.mCurrLines])},
Common.LINE_CONN_SERVICE_TIMEOUT);for(var index in lineLinks)this.requestService(lineLinks[index])};
LineHandler.prototype.requestService=function(lineLink){if(this.mIsCancel||this.mIsAlreadyChoose||null==lineLink||""===lineLink)return;Log.info(this.getLogTag(),"Request "+lineLink);var urlObj=Url.parse(lineLink);var HttpReq=require("http");if(urlObj.protocol=="https:")HttpReq=require("https");const options={protocol:urlObj.protocol,hostname:urlObj.hostname,port:urlObj.port,path:urlObj.path,method:"GET",rejectUnauthorized:false};var request=HttpReq.request(options);request.on("response",(response)=>
{response.on("data",(chunk)=>{});response.on("end",()=>{if(!this.mIsCancel&&!this.mIsAlreadyChoose){clearTimeout(this.mTimer);this.mTimer=null;Log.info(this.getLogTag(),"The first line finishing requesting data is "+lineLink);this.requestDone(lineLink)}})});request.on("error",(error)=>{if(!this.mIsCancel&&!this.mIsAlreadyChoose)Log.warning(this.getLogTag(),"Request "+lineLink+" error!")});request.end()};
LineHandler.prototype.requestDone=function(lineLink){if(this.mIsCancel||this.mIsAlreadyChoose)return;Log.info(this.getLogTag(),"Request lineLinks successfully and the lineLink is "+lineLink);this.mIsAlreadyChoose=true;if(!ECUtil.isHttpsAddr(lineLink))ECEvent.emit(Common.EVENT_SELECT_LINE_AGAIN,lineLink,this.mIsChangeLine);else if(!this.mIsCancel){var urlObj=Url.parse(lineLink);const options={protocol:urlObj.protocol,hostname:urlObj.hostname,port:urlObj.port,method:"GET",timeout:1E3,rejectUnauthorized:false};
Log.debug(Common.LOG_LINE_HANDLER_TAG,JSON.stringify(options,null,4));var req=Https.request(options);global.reqTimer=setTimeout(()=>{Log.info(Common.LOG_LINE_HANDLER_TAG,"Request "+lineLink+" timeout");req.abort()},Common.SELECT_LINE_REQUEST_PAGE_TIMEOUT);const dns=require("dns");dns.lookup(urlObj.hostname,(err,addr)=>{if(err)Log.info(Common.LOG_LINE_HANDLER_TAG,"Dns "+urlObj.hostname+"err: "+err);else Log.info(Common.LOG_LINE_HANDLER_TAG,"Hostname: "+urlObj.hostname+" ip address: "+addr)});req.once("response",
(res)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(this.mIsCancel)return;Log.debug(Common.LOG_LINE_HANDLER_TAG,"Response statusCode: "+res.statusCode);if(res.statusCode!==Common.HTTP_REQUEST_STATUS_OK){this.mCurrLines++;if(this.mCurrLines>=this.mLineLinksArray.length){if(!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,Common.LINE_ERROR_CODE_NOT_CONN)}else{this.mIsAlreadyChoose=false;this.peekBestLine(this.mLineLinksArray[this.mCurrLines])}return}Log.info(Common.LOG_LINE_HANDLER_TAG,
"Response from lineLink!");if(!this.mIsCancel)if(this.mIsChangeLine)ECEvent.emit(Common.EVENT_CHANGE_LINE,ECUtil.getHttpsAddr(lineLink));else ECEvent.emit(Common.EVENT_SELECT_LINE_SUCCESSFULLY,ECUtil.getHttpsAddr(lineLink))});req.on("error",(error)=>{if(reqTimer!=null){clearTimeout(reqTimer);reqTimer=null}if(this.mIsCancel)return;Log.warning(Common.LOG_LINE_HANDLER_TAG,"Request "+lineLink+" error: "+error);if(!this.mIsCancel){this.mCurrLines++;if(this.mCurrLines>=this.mLineLinksArray.length){if(!this.mIsChangeLine)ECEvent.emit(Common.EVENT_SELECT_LINE_ERROR,
Common.LINE_ERROR_CODE_NOT_CONN)}else{this.mIsAlreadyChoose=false;this.peekBestLine(this.mLineLinksArray[this.mCurrLines])}}});req.end()}if(this.mTimer!=null){clearTimeout(this.mTimer);this.mTimer=null}};LineHandler.prototype.getLines=function(content){};LineHandler.prototype.getLogTag=function(content){return Common.LOG_LINE_HANDLER_TAG};module.exports=LineHandler;
