'use strict';const {Tray,Menu,MenuItem,nativeImage}=require("electron");const App=require("electron").app;const IPCMian=require("electron").ipcMain;const Path=require("path");const FS=require("fs");const Https=require("https");const Common=require("../../common");const ECEvent=require("../../service/lib/ec_event");const ECUtil=require("../../service/lib/ec_util");const ECI18n=require("../../service/lib/ec_i18n");const Log=require("../../service/lib/ec_log");
function ECTray(type){this.mType=type;this.mInit=false;this.mEnableUrl=true;this.mAppTrayIco=Common.APP_TRAY_ICO;this.mAppTrayInitializing1Ico=Common.APP_INITIALIZING_TRAY_ICO_1;this.mAppTrayInitializing2Ico=Common.APP_INITIALIZING_TRAY_ICO_2;this.mAppTrayBlackIco=Common.APP_TRAY_ICO;this.mAppTrayOfflineIco=Common.APP_OFFLINE_TRAY_ICO;this.mAppTrayWhiteIco=Common.APP_PRESS_TRAY_ICO;if(gOS===Common.SYS_LINUX){this.mAppTrayIco=Common.APP_TRAY_ICO_LINUX;this.mAppTrayInitializing1Ico=Common.APP_INITIALIZING_TRAY_ICO_LINUX_1;
this.mAppTrayInitializing2Ico=Common.APP_INITIALIZING_TRAY_ICO_LINUX_2;this.mAppTrayBlackIco=Common.APP_TRAY_BLACK_ICO_LINUX;this.mAppTrayOfflineIco=Common.APP_OFFLINE_TRAY_ICO_LINUX;this.mAppTrayWhiteIco=Common.APP_TRAY_WHITE_ICO_LINUX;if(gControllers.conf.getUrl(null,"tray_url_enable")===false&&gStartFromECAgent)this.mEnableUrl=false}}
ECTray.prototype.init=function(){if(this.mInit)return;this.mInit=true;if(this.mType!==Common.TRAY_NO_ICO&&this.mType!==Common.TRAY_HAVE_ICO)this.mType=Common.TRAY_HAVE_ICO;this.mVerInfo=null;this.mCheckUpdateTimer=null;this.mAppTray=null;this.mStatusWindow=null;this.mSettingWindow=null;this.mHistoryWindow=null;this.mLoginInfoWindow=null;this.mTimer=null;this.mInitIntervarl=null;this.mFlag=true;this.mOnlineInterval=null;this.mOnlineFlag=0;this.mIniMenu=null;this.mTrayMenu=null;this.mTrayStatus=Common.TRAY_INITIALIZING;
if(this.mType===Common.TRAY_HAVE_ICO)this.createTray();if(gOS!==Common.SYS_LINUX)this.mHistoryWindow=this.createWindow(460,463,Common.HISTORY_MESSAGE_URL);if(!gAuthInfo[Common.AUTHINFO_IS_PUB_USER]&&gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_SWITCH]==Common.LAST_LOGIN_SWITCH_OPEN&&(gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_RES]===Common.LOGIN_RES_SUCCESS||gECTrayInfo[Common.ECTRAYINFO_LAST_LOGIN_RES]===Common.LOGIN_RES_FAILED))this.createLoginInfoWin();this.initTimer();this.initApp();this.initIPCMainEvent();
this.initEvent();this.initWinEvent()};
ECTray.prototype.createLoginInfoWin=function(){this.mLoginInfoWindow=this.createWindow(350,250,Common.LOGIN_INFO_URL);this.mLoginInfoWindow.setAlwaysOnTop(true);var x=0,y=0;const screen=require("electron").screen;var size=screen.getPrimaryDisplay().workAreaSize;x=size.width-350;if(gOS==Common.SYS_MAC)y=0;else{var trayType=gControllers.conf.getUrl(null,"tray_type");if(trayType==="float")y=144;else y=size.height-250}this.mLoginInfoWindow.setPosition(x,y);this.mLoginInfoWindow.once("ready-to-show",()=>
{this.mLoginInfoWindow.show()})};
ECTray.prototype.initVerInfo=function(){var verXml=FS.readFileSync(Common.VERSION_CONF_PATH,{encode:"UTF-8"});const xml2js=require("../../node_modules/xml2js");var parser=new xml2js.Parser;parser.parseString(verXml,(err,result)=>{if(err){Log.warning(Common.LOG_EC_TRAY,"parseString error: "+err);return}Log.debug(Common.LOG_EC_TRAY,JSON.stringify(result));this.mVerInfo={};try{this.mVerInfo["alias"]=result["root"]["alias"][0];this.mVerInfo["version"]=result["root"]["version"][0];if(gOS===Common.SYS_LINUX){this.mVerInfo["pkg"]=
result["root"]["pkg"][0];this.mVerInfo["arch"]=result["root"]["arch"][0]}Log.debug(Common.LOG_EC_TRAY,"gOS: "+gOS);Log.info(Common.LOG_EC_TRAY,"VerInfo: "+JSON.stringify(this.mVerInfo));this.initCheckUpdateTimer()}catch(e){Log.error(Common.LOG_EC_TRAY,"error: "+e)}})};
ECTray.prototype.createTray=function(){this.mAppTray=new Tray(this.mAppTrayIco);this.mTrayMenu=this.createTrayMenu();this.mIniMenu=Menu.buildFromTemplate([{label:ECI18n("Quit"),click:()=>{this.quitClick()}}]);this.mAppTray.setPressedImage(nativeImage.createFromPath(this.mAppTrayWhiteIco));this.mAppTray.setToolTip(ECI18n("Initializing services..."));this.mAppTray.setContextMenu(this.mIniMenu);this.trayInitGif()};
ECTray.prototype.trayInitGif=function(){if(this.mAppTray!=null)this.mInitIntervarl=setInterval(()=>{if(this.mFlag){this.mAppTray.setImage(this.mAppTrayInitializing1Ico);this.mFlag=false}else{this.mAppTray.setImage(this.mAppTrayInitializing2Ico);this.mFlag=true}},200)};ECTray.prototype.clearTrayInitGif=function(){if(this.mInitIntervarl!=null){clearInterval(this.mInitIntervarl);this.mInitIntervarl=null}};ECTray.prototype.setTrayOffline=function(){if(this.mAppTray!=null)this.mAppTray.setImage(this.mAppTrayOfflineIco)};
ECTray.prototype.setTrayOnline=function(){if(this.mTrayStatus===Common.TRAY_INITIALIZING)return;if(this.mAppTray!=null)this.mAppTray.setImage(this.mAppTrayIco);this.trayOnlineGif()};
ECTray.prototype.trayOnlineGif=function(){if(this.mAppTray!=null)this.mOnlineInterval=setInterval(()=>{switch(this.mOnlineFlag%4){case 0:this.mAppTray.setImage(this.mAppTrayBlackIco);this.mOnlineFlag=0;break;case 1:this.mAppTray.setImage(this.mAppTrayOfflineIco);break;case 2:this.mAppTray.setImage(this.mAppTrayWhiteIco);break;case 3:this.mAppTray.setImage(this.mAppTrayOfflineIco);break}this.mOnlineFlag++},200);setTimeout(()=>{this.clearTrayOnlineGif()},5E3)};
ECTray.prototype.clearTrayOnlineGif=function(){if(this.mOnlineInterval!=null){clearInterval(this.mOnlineInterval);this.mOnlineInterval=null}this.mAppTray.setImage(this.mAppTrayIco)};
ECTray.prototype.createTrayMenu=function(){var menuTemplate=[{label:ECI18n("Connection Status"),click:()=>{this.statusClick()}},{label:"sep1",type:"separator"},{label:ECI18n("Personal Setup"),enabled:this.mEnableUrl,visible:this.mEnableUrl,click:()=>{this.personalSetting()}},{label:ECI18n("System Setup"),click:()=>{this.settingClick()}},{label:"sep2",type:"separator"},{label:ECI18n("Resources"),enabled:this.mEnableUrl,visible:this.mEnableUrl,click:()=>{this.showResource()}},{label:ECI18n("Quit"),
click:()=>{this.quitClick()}}];var hisMenuItem={label:ECI18n("Messages"),click:()=>{this.historyMsgClick()}};if(gOS!==Common.SYS_LINUX)menuTemplate.splice(1,0,hisMenuItem);const contextMenu=Menu.buildFromTemplate(menuTemplate);if(!this.mEnableUrl)return contextMenu;var sep3=new MenuItem({label:"sep3",visible:this.mEnableUrl,type:"separator"});if(gOS===Common.SYS_LINUX)contextMenu.insert(6,sep3);else contextMenu.insert(7,sep3);if(gConf!=null&&"Conf"in gConf&&"RemoteApp"in gConf.Conf&&"PublicPath"in
gConf.Conf.RemoteApp){var pubPath=gConf.Conf.RemoteApp.PublicPath;var subMenu=new Menu;if(pubPath instanceof Array)for(var i=0;i<pubPath.length;++i){var mi=new MenuItem({label:pubPath[i]["#text"],id:pubPath[i]["storage_id"],enabled:this.mEnableUrl,click:(menuItem)=>{this.openPubDir(menuItem)}});subMenu.append(mi)}else{var mi=new MenuItem({label:pubPath["#text"],id:pubPath["storage_id"],click:(menuItem)=>{this.openPubDir(menuItem)}});subMenu.append(mi)}var pubMenu=new MenuItem({label:ECI18n("Public Directory"),
submenu:subMenu});if(gOS===Common.SYS_LINUX)contextMenu.insert(4,pubMenu);else contextMenu.insert(5,pubMenu);gECTrayInfo.pubDir=gConf.Conf.RemoteApp.PublicPath}if(gConf!=null&&"Conf"in gConf&&"RemoteApp"in gConf.Conf&&"PrivatePath"in gConf.Conf.RemoteApp){var pubMenu=new MenuItem({label:ECI18n("Private Directory"),id:gConf.Conf.RemoteApp.PrivatePath["storage_id"],enabled:this.mEnableUrl,click:(menuItem)=>{this.openPriDir(menuItem)}});if(gOS===Common.SYS_LINUX)contextMenu.insert(5,pubMenu);else contextMenu.insert(6,
pubMenu);gECTrayInfo.priDir=gConf.Conf.RemoteApp.PrivatePath}return contextMenu};
ECTray.prototype.initTrayEvent=function(){this.mAppTray.on("click",()=>{Log.debug(Common.LOG_EC_TRAY,"Tray click and the current status is "+this.mTrayStatus);switch(this.mTrayStatus){case Common.TRAY_INITIALIZING:this.mAppTray.popUpContextMenu(this.mIniMenu);break;case Common.TRAY_NORMAL:if(this.mTrayMenu==null)this.mTrayMenu=this.createTrayMenu();this.mAppTray.popUpContextMenu(this.mTrayMenu);break;case Common.TRAY_NEW_MESSAGE:this.mAppTray.setImage(this.mAppTrayIco);this.mAppTray.setPressedImage(this.mAppTrayWhiteIco);
this.historyMsgClick();this.mTrayStatus=Common.TRAY_NORMAL;break;default:break}})};ECTray.prototype.setTrayStatus=function(status){if(status!==Common.TRAY_INITIALIZING&&status!==Common.TRAY_NORMAL&&status!==Common.TRAY_NEW_MESSAGE)return;this.mTrayStatus=status;if(status===Common.TRAY_NORMAL)if(this.mAppTray!=null){this.mAppTray.setToolTip("");this.mAppTray.setImage(this.mAppTrayIco);this.clearTrayInitGif();if(this.mTrayMenu==null)this.mTrayMenu=this.createTrayMenu();this.mAppTray.setContextMenu(this.mTrayMenu)}};
ECTray.prototype.destroy=function(){if(this.mCheckUpdateTimer!=null){clearTimeout(this.mCheckUpdateTimer);this.mCheckUpdateTimer=null}this.clearTimer();if(this.mStatusWindow!=null){this.mStatusWindow.close();this.mStatusWindow=null}if(this.mSettingWindow!=null){this.mSettingWindow.close();this.mSettingWindow=null}if(this.mHistoryWindow!=null){this.mHistoryWindow.close();this.mHistoryWindow=null}if(this.mAppTray!=null){this.mAppTray.setContextMenu(this.mTrayMenu);this.mAppTray.destroy()}};
ECTray.prototype.initTimer=function(){if(this.mTimer==null)this.mTimer=setInterval(this.timerCallBack,Common.CHECK_STATUS_TIMER)};ECTray.prototype.clearTimer=function(){if(this.mTimer!=null)clearInterval(this.mTimer);this.mTimer=null};
ECTray.prototype.timerCallBack=function(){if(gControllers.httpsCom!=null)gControllers.httpsCom.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY TRAYSTAT",callback:Common.QUERRY_TRAY_STAT_CALLBACK});if(gOS!==Common.SYS_LINUX&&gControllers.httpsCom!=null)gControllers.httpsCom.requestECAgent(Common.HTTPS_DO_QUERY,{arg1:"QUERY MESSAGES",callback:Common.QUERRY_MESSAGES_CALLBACK})};
ECTray.prototype.initCheckUpdateTimer=function(){var lastCheckTime=gControllers.conf.getUrl(null,"last_check_update_time");var currTime=(new Date).getTime();if(lastCheckTime==null||currTime-lastCheckTime>Common.CHECK_UPDATE_TIMER_INTERVAL||currTime<lastCheckTime)this.checkUpdate();else{var time=gCheckUpdateTime-(currTime-lastCheckTime);this.mCheckUpdateTimer=setTimeout(()=>{this.checkUpdate()},time)}};
ECTray.prototype.checkUpdate=function(){Log.info(Common.LOG_EC_TRAY,"Start Checking Update...");gControllers.conf.setUrl(null,"last_check_update_time",(new Date).getTime());gControllers.conf.save();var HttpReq=require("http");if(ECUtil.isHttpsAddr(gLeVersionUrl))HttpReq=require("https");var req=HttpReq.request(gLeVersionUrl,(res)=>{res.setEncoding("utf8");var leVerXml=null;res.on("data",(chunk)=>{if(leVerXml==null)leVerXml=chunk.toString();else leVerXml+=chunk.toString()});res.on("end",()=>{const xml2js=
require("../../node_modules/xml2js");var parser=new xml2js.Parser;parser.parseString(leVerXml,(err,result)=>{if(err){Log.warning(Common.LOG_EC_TRAY,"parseString error: "+err);return}Log.debug(Common.LOG_EC_TRAY,"leVerJSON: "+JSON.stringify(result));try{var os="mac";if(gOS===Common.SYS_MAC)os="mac";else if(gOS===Common.SYS_LINUX)os="linux";var alias=this.mVerInfo["alias"];var leVer=null;if(gOS===Common.SYS_MAC)leVer=result["root"][os][0][alias][0]["force_update_le"][0];else if(gOS===Common.SYS_LINUX)leVer=
result["root"][os][0][alias][0][this.mVerInfo["pkg"]][0][this.mVerInfo["arch"]][0]["force_update_le"][0];Log.debug(Common.LOG_EC_TRAY,"leVer: "+leVer+" currVer: "+this.mVerInfo["version"]);if(this.cmpVer(leVer,this.mVerInfo["version"])){Log.info(Common.LOG_EC_TRAY,"Need update next time!");gControllers.conf.setUrl(null,"force_update",true);gControllers.conf.save()}else{gControllers.conf.setUrl(null,"force_update",false);gControllers.conf.save();Log.info(Common.LOG_EC_TRAY,"Do not need update next time!")}}catch(e){Log.error(Common.LOG_EC_TRAY,
"error: "+e)}this.mCheckUpdateTimer=setTimeout(()=>{this.checkUpdate()},gCheckUpdateTime)})})});req.on("error",(error)=>{Log.warning(Common.LOG_EC_TRAY,"request error: "+error)});req.end()};
ECTray.prototype.cmpVer=function(leVer,currVer){if(leVer==null)return false;if(currVer==null)return true;Log.info(Common.LOG_EC_TRAY,"Compare(leVer: "+leVer+" currVer: "+currVer+")");var leVerArray=leVer.split(".");var currVerArray=currVer.split(".");var maxLen=leVerArray.length>currVerArray.length?leVerArray.length:currVerArray.length;for(var i=0;i<maxLen;++i){var leInt=0,currInt=0;if(leVerArray[i]!=null)try{leInt=parseInt(leVerArray[i]);if(isNaN(leInt))leInt=0}catch(e){leInt=0}if(currVerArray[i]!=
null)try{currInt=parseInt(currVerArray[i]);if(isNaN(currInt))currInt=0}catch(e){currInt=0}Log.debug(Common.LOG_EC_TRAY,"leInt: "+leInt+" currInt: "+currInt);if(leInt>currInt)return true;else if(leInt<currInt)return false}return true};ECTray.prototype.quitClick=function(){ECUtil.doLogout()};
ECTray.prototype.statusClick=function(){if(this.mStatusWindow!=null){this.mStatusWindow.focus();return}this.mStatusWindow=this.createWindow(460,463,Common.CONNECT_STATUS_URL);this.mStatusWindow.on("close",()=>{this.mStatusWindow=null});this.mStatusWindow.once("ready-to-show",()=>{this.mStatusWindow.show()})};ECTray.prototype.historyMsgClick=function(){if(this.mHistoryWindow==null)this.mHistoryWindow=this.createWindow(460,463,Common.HISTORY_MESSAGE_URL);this.mHistoryWindow.show()};
ECTray.prototype.personalSetting=function(){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+"/por/shortcut.csp?type\x3dcs\x26destUrl\x3dsvpnSetting.csp\x26is_reminded\x3d1\x26language\x3d"+gLanguage+"\x26ea_port\x3d"+gECAgent["port"]+"\x26id\x3d"+gAuthInfo["currToken"])};
ECTray.prototype.openPubDir=function(menuItem){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+"/por/shortcut.csp?type\x3dcs\x26destUrl\x3dwebfs.csp\x26rapp_storage_id\x3d"+menuItem.id+"\x26rcid\x3d-9999\x26language\x3d"+gLanguage+"\x26is_reminded\x3d1\x26ea_port\x3d"+gECAgent["port"]+"\x26id\x3d"+gAuthInfo["currToken"])};
ECTray.prototype.openPriDir=function(menuItem){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+"/por/shortcut.csp?type\x3dcs\x26destUrl\x3dwebfs.csp\x26rapp_storage_id\x3d"+menuItem.id+"\x26rcid\x3d-9999\x26language\x3d"+gLanguage+"\x26is_reminded\x3d1\x26ea_port\x3d"+gECAgent["port"]+"\x26id\x3d"+gAuthInfo["currToken"])};
ECTray.prototype.settingClick=function(){if(this.mSettingWindow!=null){this.mSettingWindow.focus();return}this.mSettingWindow=this.createWindow(460,193,Common.PREFERENCE_SETTING_URL);this.mSettingWindow.on("close",()=>{this.mSettingWindow=null});this.mSettingWindow.once("ready-to-show",()=>{this.mSettingWindow.show()})};
ECTray.prototype.showResource=function(){ECUtil.openExternalUrl(gBrowser,gAuthInfo["authUrl"]+"/por/shortcut.csp?type\x3dcs\x26destUrl\x3dservice.csp\x26autoOpen\x3d0\x26language\x3d"+gLanguage+"\x26is_reminded\x3d1\x26ea_port\x3d"+gECAgent["port"]+"\x26id\x3d"+gAuthInfo["currToken"])};
ECTray.prototype.createWindow=function(width,height,url){if(width==null)width=460;if(height==null)height=463;var options={width:width,height:height,resizable:false,center:true,show:false,frame:false,fullscreen:false,icon:Common.APP_LOGO,webPreferences:{javascript:true,plugins:true,nodeIntegration:false,webSecurity:false,preload:Path.join(__dirname,"./preload.js")}};const BrowserWindow=require("electron").BrowserWindow;if(gOS===Common.SYS_MAC){options["titleBarStyle"]="hidden";options["maximizable"]=
false}var win=new BrowserWindow(options);win.loadURL(url);return win};
ECTray.prototype.initIPCMainEvent=function(){IPCMian.on(Common.EVENT_RENDER_CLOSE_TRAY_WINDOW,(event,win)=>{switch(win){case Common.TRAY_WINDOW_STATUS:if(this.mStatusWindow!=null)this.mStatusWindow.close();break;case Common.TRAY_WINDOW_HISTORY_MESSAGE:if(this.mHistoryWindow!=null)this.mHistoryWindow.hide();break;case Common.TRAY_WINDOW_PREFERENCE_SETTING:if(this.mSettingWindow!=null)this.mSettingWindow.close();break;case Common.TRAY_WINDOW_LOGIN_INFO:if(this.mLoginInfoWindow!=null)this.mLoginInfoWindow.close();
this.mLoginInfoWindow=null;break;default:break}});IPCMian.on(Common.EVENT_RENDER_MINIMIZE_TRAY_WINDOW,(event,win)=>{switch(win){case Common.TRAY_WINDOW_STATUS:if(this.mStatusWindow!=null)this.mStatusWindow.minimize();break;case Common.TRAY_WINDOW_HISTORY_MESSAGE:if(this.mHistoryWindow!=null)this.mHistoryWindow.minimize();break;case Common.TRAY_WINDOW_PREFERENCE_SETTING:if(this.mSettingWindow!=null)this.mSettingWindow.minimize();break;case Common.TRAY_WINDOW_LOGIN_INFO:if(this.mLoginInfoWindow!=null)this.mLoginInfoWindow.minimize();
break;default:break}});IPCMian.on(Common.EVENT_RENDER_SAVE_SETTING,(event,argObj)=>{Log.debug(Common.LOG_EC_TRAY,"Received ipc_render_event: "+Common.EVENT_RENDER_SAVE_SETTING+" argObj: "+JSON.stringify(argObj));if(argObj==null)Log.warning(Common.LOG_EC_TRAY,"The argObj is null!");if(gControllers.conf!=null){if("autoLogin"in argObj){gControllers.conf.set("auto_login",argObj["autoLogin"]);if(argObj["autoLogin"]){gControllers.conf.set("save_psw",true);argObj["savePsw"]=true}}if("savePsw"in argObj){gControllers.conf.set("save_psw",
argObj["savePsw"]);if(argObj["savePsw"]){if(gAuthInfo.userName!=null&&gAuthInfo.userName!="")gControllers.conf.set("user_name",gAuthInfo.userName);if(gAuthInfo.psw!=null&&gAuthInfo.psw!="")gControllers.conf.set("psw",ECUtil.encryptPsw(gAuthInfo.psw))}}gControllers.conf.save()}})};ECTray.prototype.initApp=function(){App.on("activate",(e,hasVisibleWindows)=>{if(this.mTrayStatus!==Common.TRAY_INITIALIZING)this.showResource()})};
ECTray.prototype.initEvent=function(){ECEvent.on(Common.EVENT_CONNECT_STATE_UPDATE,(statInfoStr)=>{if(statInfoStr!=null&&statInfoStr!==""&&this.mStatusWindow!=null)this.mStatusWindow.webContents.send(Common.EVENT_MAIN_STATE_UPDATE,statInfoStr)});ECEvent.on(Common.EVENT_NEW_MESSAGE,(newMsgs)=>{Log.debug(Common.LOG_EC_TRAY,"Receive ec_event: "+Common.EVENT_NEW_MESSAGE);if(newMsgs.length>0){if(this.mTrayStatus===Common.TRAY_NORMAL){this.mAppTray.setContextMenu(this.mTrayMenu);this.mAppTray.destroy();
this.mTrayStatus=Common.TRAY_NEW_MESSAGE;this.mAppTray=null;this.mTrayMenu=null;this.mAppMsgTray=new Tray(Common.APP_NEW_MSG_TRAY_ICO);this.mAppMsgTray.setPressedImage(Common.APP_PRESS_NEW_MSG_TRAY_ICO);this.mAppMsgTray.once("click",()=>{this.historyMsgClick();this.mTrayStatus=Common.TRAY_NORMAL;this.mAppTray=this.mAppMsgTray;this.mAppMsgTray=null;this.mAppTray.setImage(this.mAppTrayIco);this.mAppTray.setPressedImage(this.mAppTrayWhiteIco);this.mTrayMenu=this.createTrayMenu();this.mAppTray.setContextMenu(this.mTrayMenu)})}var dateStr=
(new Date).Format("yyyy-MM-dd hh:mm:ss");if(this.mHistoryWindow!=null)this.mHistoryWindow.webContents.send(Common.EVENT_MAIN_NEW_MESSAGE,dateStr,newMsgs)}})};ECTray.prototype.initWinEvent=function(){if(this.mHistoryWindow!=null)this.mHistoryWindow.on("close",(e)=>{e.preventDefault();if(this.mHistoryWindow!=null){if(this.mHistoryWindow.webContents.isDevToolsOpened())this.mHistoryWindow.webContents.closeDevTools();this.mHistoryWindow.hide()}})};module.exports=ECTray;
