'use strict';const {BrowserWindow,ipcMain,Menu}=require("electron");const Common=require("../../common");const ECI18n=require("../../service/lib/ec_i18n");const ECTray=require("./ec_tray");const Log=require("../../service/lib/ec_log");const Path=require("path");function FloatWindow(type){this.createWindow();this.mInit=false;this.mTrayStatus=Common.TRAY_INITIALIZING}
FloatWindow.prototype.init=function(){if(this.mInit)return;this.mInit=true;this.mWindow.show();this.mTray=new ECTray(Common.TRAY_NO_ICO);this.mTray.init();this.createContextMenu()};
FloatWindow.prototype.createWindow=function(){const screen=require("electron").screen;var size=screen.getPrimaryDisplay().workAreaSize;var options={width:64,height:64,x:size.width-80,y:80,resizable:false,center:true,show:false,frame:false,backgroundColor:"#99FFFFFF",fullscreen:false,alwaysOnTop:true,transparent:true,icon:Common.APP_LOGO,webPreferences:{javascript:true,plugins:true,nodeIntegration:false,webSecurity:false,preload:Path.join(__dirname,"./preload.js")}};this.mWindow=new BrowserWindow(options);
this.mWindow.loadURL(Common.FLOAT_WINDOW_URL);this.mWindow.once("ready-to-show",()=>{if(this.mTrayStatus===Common.TRAY_NORMAL)this.mWindow.webContents.send(Common.EVENT_MAIN_SET_FLOAT_WINDOW_STATE,Common.TRAY_NORMAL)});this.mWindow.on("close",()=>{if(this.mTray!=null)this.mTray.quitClick()})};FloatWindow.prototype.destroy=function(){this.mTray.destroy();if(this.mWindow!=null){this.mWindow.destroy();this.mWindow=null}};
FloatWindow.prototype.setTrayOnline=function(){this.mWindow.webContents.send(Common.EVENT_MAIN_SET_FLOAT_WINDOW_STATE,Common.TRAY_ONLINE)};FloatWindow.prototype.setTrayOffline=function(){this.mWindow.webContents.send(Common.EVENT_MAIN_SET_FLOAT_WINDOW_STATE,Common.TRAY_OFFLINE)};
FloatWindow.prototype.setTrayStatus=function(status){if(status!==Common.TRAY_INITIALIZING&&status!==Common.TRAY_NORMAL&&status!==Common.TRAY_NEW_MESSAGE)return;this.mTrayStatus=status;Log.debug(Common.LOG_FLOAT_WINDOW_TAG,"Send main_event: "+Common.EVENT_MAIN_SET_FLOAT_WINDOW_STATE);this.mWindow.webContents.send(Common.EVENT_MAIN_SET_FLOAT_WINDOW_STATE,Common.TRAY_NORMAL)};FloatWindow.prototype.clearTimer=function(){if(this.mTray!=null)this.mTray.clearTimer()};
FloatWindow.prototype.initTimer=function(){if(this.mTray!=null)this.mTray.initTimer()};FloatWindow.prototype.createContextMenu=function(){this.mContextMenu=this.mTray.createTrayMenu();this.mInitMenu=Menu.buildFromTemplate([{label:ECI18n("Quit"),click:()=>{this.mTray.quitClick()}}]);ipcMain.on(Common.EVENT_RENDER_FLOAT_WINDOW_CONTEXT_MENU,(e)=>{e.preventDefault();if(this.mTrayStatus===Common.TRAY_INITIALIZING)this.mInitMenu.popup(this.mWindow);else this.mContextMenu.popup(this.mWindow)})};
module.exports=FloatWindow;
